unit ucharset;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, UDIBSurf, Spin, USprite, UMameChr;

type
  TfrmCharSet = class(TForm)
    Panel1: TPanel;
    pnlScreen: TPanel;
    bbOk: TBitBtn;
    pbScreen: TPaintBox;
    seZoom: TSpinEdit;
    Zoom: TLabel;
    Label1: TLabel;
    sePalette: TSpinEdit;
    seSet: TSpinEdit;
    Label2: TLabel;
    procedure pbScreenPaint(Sender: TObject);
    procedure seZoomChange(Sender: TObject);
    procedure sePaletteChange(Sender: TObject);
    procedure seSetChange(Sender: TObject);
  private
    { Private declarations }
    nSet,
    nSets,
    nPalette,
    nZoom: Integer;
    aXSprite: PArrayGFXElement;
    aSprite: PSpriteSet;
    nMaxSprite: Integer;
    cCaption: String;
  public
    { Public declarations }
    procedure SetType(xSprite: PSpriteSet; nMax, aSets: Integer; cStr: String);
    procedure SetTypeX(xSprite: PArrayGFXElement; nMax, aSets: Integer; cStr: String);
  end;

var
  frmCharSet: TfrmCharSet;

implementation

{$R *.DFM}

procedure TfrmCharSet.SetType(xSprite: PSpriteSet; nMax, aSets: Integer; cStr: String);
begin
  aSprite := xSprite;
  nMaxSprite := nMax;
  cCaption := cStr;
  Caption := cCaption;
  nSets := aSets;
  nSet := 0;
  nSet := 0;
  nZoom := 3;

  nPalette := 0;

  seZoom.Value := nZoom;
  sePalette.Value := nPalette;
  seSet.Value := nSet;
  seSet.MaxValue := nSets-1;
  seSet.Enabled := nSets>1;
end;

procedure TfrmCharSet.SetTypeX(xSprite: PArrayGFXElement; nMax, aSets: Integer; cStr: String);
begin
  aXSprite := xSprite;
  {
  aSprite := aXSprite^[0]
  nMaxSprite := nMax;
  cCaption := cStr;
  Caption := cCaption;
  nSets := aSets;
  nSet := 0;
  nSet := 0;
  nZoom := 3;

  nPalette := 0;

  seZoom.Value := nZoom;
  sePalette.Value := nPalette;
  seSet.Value := nSet;
  seSet.MaxValue := nSets-1;
  seSet.Enabled := nSets>1;
  }
end;


procedure TfrmCharSet.pbScreenPaint(Sender: TObject);
var
  nZX, nZY, nColor, I, J, nX, nY, nSprite: Integer;
begin
  with pbScreen.Canvas do begin
    gdiSelectPalette(Handle, DIBhpalette, 0);
    Brush.Style := BSSOLID;
    Brush.Color := CLBLACK;
    Rectangle(0, 0, pbScreen.Width, pbScreen.Height);

    nX := 9999;
    nY := 9999;

    for nSprite := 0 to nMaxSprite-1 do begin
      if (nX+2+aSprite^[nSprite+nSet*nMaxSprite]^.W*nZoom)>pbScreen.Width then begin
        nX := 2;
        nY := nY+nZoom*aSprite^[nSprite+nSet*nMaxSprite]^.H+2;
        if (nY+2+nZoom*aSprite^[nSprite+nSet*nMaxSprite]^.H)>pbScreen.Height then nY := 2;
      end;

      for i := 0 to aSprite^[nSprite+nSet*nMaxSprite]^.W-1 do begin
        for j := 0 to aSprite^[nSprite+nSet*nMaxSprite]^.H-1 do begin
          nColor := aSprite^[nSprite+nSet*nMaxSprite]^.aData[i+j*aSprite^[nSprite+nSet*nMaxSprite]^.W];
          if nColor<>0 then begin
            for nZX := 1 to nZoom do
              for nZY := 1 to nZoom do
                Pixels[nX+nZoom*i+nZX, nY+nZoom*j+nZY] := $01000000+nColor+4*nPalette+10;
          end;
        end;
      end;

      nX := nX+2+nZoom*aSprite^[nSprite+nSet*nMaxSprite]^.W;
    end;

  end;
end;

procedure TfrmCharSet.seZoomChange(Sender: TObject);
begin
  nZoom := seZoom.Value;
  pbScreen.Refresh;
end;

procedure TfrmCharSet.sePaletteChange(Sender: TObject);
begin
  nPalette := sePalette.Value;
  pbScreen.Refresh;
end;

procedure TfrmCharSet.seSetChange(Sender: TObject);
begin
  nSet := seSet.Value;
  if (nSet<0) or (nSet>=nSets) then begin
    nSet := 0;
    seSet.Value := nSet;
  end;
  pbScreen.Refresh;
end;

end.
