unit udebug;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

const
  STATE_RUNNING = 0;
  STATE_PAUSED  = 1;
  STATE_STEP    = 2;  

type
  TfrmDebug = class(TForm)
    Label3: TLabel;
    lblAF: TLabel;
    Label4: TLabel;
    lblBC: TLabel;
    lblDE: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    lblHL: TLabel;
    Label14: TLabel;
    lblPC: TLabel;
    lblSP: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    lblIY: TLabel;
    lblIX: TLabel;
    Label21: TLabel;
    Panel1: TPanel;
    sbPause: TSpeedButton;
    sbStep: TSpeedButton;
    sbPlay: TSpeedButton;
    sbAddWatch: TSpeedButton;
    Label5: TLabel;
    lblSFlag: TLabel;
    lblZFlag: TLabel;
    lblHFlag: TLabel;
    lblPFlag: TLabel;
    lblNFlag: TLabel;
    lblCFlag: TLabel;
    lblBit5Flag: TLabel;
    lblBit3Flag: TLabel;
    Bevel1: TBevel;
    lbWatches: TListBox;
    Label6: TLabel;
    sbDelWatch: TSpeedButton;
    procedure sbPauseClick(Sender: TObject);
    procedure sbPlayClick(Sender: TObject);
    procedure sbStepClick(Sender: TObject);
    procedure sbAddWatchClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbWatchesDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure edBrkPointKeyPress(Sender: TObject; var Key: Char);
    procedure sbDelWatchClick(Sender: TObject);
  private
    { Private declarations }
    nState: Byte;
    aResult: array[0..31] of String[4];
  public
    { Public declarations }
    function GetDebugState: Integer;
    procedure SetDebugState(aState: Integer);
    procedure SetPos(nX, nY, nW, nH: Integer);
    procedure ClearList;
    procedure EvalWatches;
  end;

var
  frmDebug: TfrmDebug;

implementation

uses uwadd, uStrings, UZ80Var;

{$R *.DFM}

procedure TfrmDebug.sbPauseClick(Sender: TObject);
begin
  SetDebugState(STATE_PAUSED);
end;

procedure TfrmDebug.sbPlayClick(Sender: TObject);
begin
  SetDebugState(STATE_RUNNING);
end;

procedure TfrmDebug.sbStepClick(Sender: TObject);
begin
  SetDebugState(STATE_STEP);
end;

function TfrmDebug.GetDebugState: Integer;
begin
  GetDebugState := nState;
end;

procedure TfrmDebug.SetDebugState(aState: Integer);
begin
  nState := aState;
  case nState of
    STATE_RUNNING: Caption := 'Debug (Running)';
    STATE_STEP: Caption := 'Debug (Step)';
    STATE_PAUSED: Caption := 'Debug (Paused)';
  end;
end;

{
          frmDebug.cbSFlag.Checked := (aZ80Regs^.AF.l and S_FLAG)<>0;
          frmDebug.cbZFlag.Checked := (aZ80Regs^.AF.l and Z_FLAG)<>0;
          frmDebug.cbHFlag.Checked := (aZ80Regs^.AF.l and H_FLAG)<>0;
          frmDebug.cbPFlag.Checked := (aZ80Regs^.AF.l and P_FLAG)<>0;
          frmDebug.cbNFlag.Checked := (aZ80Regs^.AF.l and N_FLAG)<>0;
          frmDebug.cbCFlag.Checked := (aZ80Regs^.AF.l and C_FLAG)<>0;
          frmDebug.cbBit5Flag.Checked := (aZ80Regs^.AF.l and $20)<>0;
          frmDebug.cbBit3Flag.Checked := (aZ80Regs^.AF.l and $08)<>0;
}

procedure TfrmDebug.sbAddWatchClick(Sender: TObject);
var
  cAux: String;
begin
  frmAddWatch.SetPos(Left+64, Top+16);
  frmAddWatch.ShowModal;
  if frmAddWatch.ModalResult=MROK then begin
    with frmAddWatch do
      cAux := edAddr.Text+','+edDesloc.Text+','+
              IntToStr(rbIndex.ItemIndex)+','+
              IntToStr(rbView.ItemIndex)+','+
              IntToStr(rbType.ItemIndex)+',?????';

    lbWatches.Items.Add(cAux);
  end;
end;

procedure TfrmDebug.SetPos(nX, nY, nW, nH: Integer);
begin
  if nX<>-1 then Left := nX;
  if nY<>-1 then Top := nY;
  if nW<>-1 then Width := nW;
  if nH<>-1 then Height := nH;
end;

procedure TfrmDebug.ClearList;
begin
  lbWatches.Items.Clear;
  lbWatches.Items.Add('0000,00,0,0,0,????');
  lbWatches.Items.Add('0000,00,1,0,0,????');
  lbWatches.Items.Add('0000,00,2,0,0,????');
  lbWatches.Items.Add('0000,00,3,0,0,????');
  lbWatches.Items.Add('0000,00,4,0,0,????');
  lbWatches.Items.Add('0000,00,6,0,0,????');
  lbWatches.Items.Add('0000,00,7,0,1,????');
end;

procedure TfrmDebug.FormCreate(Sender: TObject);
begin
  ClearList;
end;

procedure TfrmDebug.lbWatchesDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  I: Integer;
  cItem, cAux: String;
  cItems: array[1..10] of String[7];
  nCont: Integer;
begin
  with lbWatches.Canvas, Rect do begin
    FillRect(Rect);

    cItem := lbWatches.Items[Index];
    nCont := 0;
    cAux := '';
    for i := 1 to Length(cItem)+1 do begin
      if (i>Length(cItem)) or (cItem[i]=',') then begin
        Inc(nCont);
        cItems[nCont] := cAux;
        cAux := '';
      end
      else begin
        cAux := cAux+cItem[i];
      end;
    end;

    cAux := '???';
    if cItems[5]<>'' then begin
      if cItems[5][1]='0' then begin
        cAux := 'bptr ';
      end
      else begin
        cAux := 'wptr ';
      end;
    end;

    if cItems[3]<>'' then begin
      case cItems[3][1] of
        '0': cAux := cAux+'[BC]';
        '1': cAux := cAux+'[DE]';
        '2': cAux := cAux+'[HL]';
        '3': cAux := cAux+'[IX+'+cItems[2]+']';
        '4': cAux := cAux+'[IY+'+cItems[2]+']';
        '5': cAux := cAux+'['+cItems[1]+']';
        '6': cAux := cAux+'[PC]';
        '7': cAux := cAux+'[SP]';
      end;
    end;

    if not (ODSELECTED in State) then Font.Color := CLBLUE;
    TextOut(left, top, cAux);

    if not (ODSELECTED in State) then Font.Color := CLRED;
    TextOut(left+48, top, aResult[Index]);

  end;
end;


procedure TfrmDebug.EvalWatches;
var
  I, nIndex, nAddr, nDesloc: Integer;
  cItem, cAux: String;
  cItems: array[1..10] of String[7];
  nCont: Integer;
begin
  for nIndex := 0 to lbWatches.Items.Count-1 do begin
    cItem := lbWatches.Items[nIndex];
    nCont := 0;
    cAux := '';
    for i := 1 to Length(cItem)+1 do begin
      if (i>Length(cItem)) or (cItem[i]=',') then begin
        Inc(nCont);
        cItems[nCont] := cAux;
        cAux := '';
      end
      else begin
        cAux := cAux+cItem[i];
      end;
    end;

    nAddr := HexToInt(cItems[1]);
    nDesloc := ShortInt(HexToInt(cItems[2]));
    if cItems[3]<>'' then begin
      case cItems[3][1] of
        '0': nAddr := aZ80Regs^.BC.W;
        '1': nAddr := aZ80Regs^.DE.W;
        '2': nAddr := aZ80Regs^.HL.W;
        '3': nAddr := aZ80Regs^.IX.W+nDesloc;
        '4': nAddr := aZ80Regs^.IY.W+nDesloc;
        '6': nAddr := aZ80Regs^.PC.W;
        '7': nAddr := aZ80Regs^.SP.W;
      end;
    end;

    cAux := '????';
    if cItems[5]<>'' then begin
      if cItems[5][1]='0' then begin
        cAux := IntToHex(aZ80Mem^[nAddr], 2);
      end
      else begin
        cAux := IntToHex(aZ80Mem^[nAddr]+256*aZ80Mem^[nAddr+1], 4);
      end;
    end;

    aResult[nIndex] := cAux;

  end;
  lbWatches.Refresh;
end;

procedure TfrmDebug.edBrkPointKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in [#8, '0'..'9', 'A'..'F', 'a'..'f']) then begin
    Key := #0;
  end;
end;

procedure TfrmDebug.sbDelWatchClick(Sender: TObject);
begin
  if lbWatches.ItemIndex>=0 then begin
    lbWatches.Items.Delete(lbWatches.ItemIndex);
  end
  else begin
    ShowMessage('You need to choose a Watch before delete it!');
  end;
end;

end.
