{$O+}
unit
  UFrogger;

interface

uses
  Classes, Windows, Forms, UDIBSurf, UZ80Var, UZ80, UGameScr, USprite, SysUtils;

  function FroggerGetByte(nEnder: Word): Byte; pascal;
  procedure FroggerPutByte(nEnder, nValue: Word); pascal;
  procedure FroggerInterrupt; pascal;
  function FroggerInByte(nEnder: Word): Byte; pascal;
  procedure FroggerOutByte(nEnder, nValue: Word); pascal;
  procedure FroggerCreateScreen;
  procedure FroggerInitDriver;


implementation


const
  aFroggerPalette: array[0..31] of Byte =
    (0,$C0,$07,$F6,0,17,$39,$F8,0,$5E,$F6,$5C,0,$C7,$39,$3F,0,$3C,$F8,$D7,
     0,$07,$F6,$39,0,$C4,$C0,$07,0,$07,$3F,$C4);

procedure FroggerInitDriver;
var
  I, nVal: Integer;
  nBit0, nBit1, nBit2: Byte;
begin
  for i := 0 to 31 do begin
    nVal := aFroggerPalette[i];
    nBit0 := (nVal shr 0) and $01;
    nBit1 := (nVal shr 1) and $01;
    nBit2 := (nVal shr 2) and $01;
    aPalette[i].R := $21*nBit0+$47*nBit1+$97*nBit2;

    nBit0 := (nVal shr 3) and $01;
    nBit1 := (nVal shr 4) and $01;
    nBit2 := (nVal shr 5) and $01;
    aPalette[i].G := $21*nBit0+$47*nBit1+$97*nBit2;

    nBit0 := 0;
    nBit1 := (nVal shr 6) and $01;
    nBit2 := (nVal shr 7) and $01;
    aPalette[i].B := $21*nBit0+$47*nBit1+$97*nBit2;
  end;

  for i := 32 to 63 do begin
    if (i and 3)<>0 then begin
      aPalette[i] := aPalette[i-32];
    end
    else begin
      aPalette[i].R := 0;
      aPalette[i].G := 0;
      aPalette[i].B := $47;
    end;
  end;
end;


procedure FroggerPutByte(nEnder, nValue: Word);
begin
  if (nEnder=$6000) or (nEnder=$6001) then exit;
  aZ80Mem[nEnder] := nValue
end;

function FroggerGetByte(nEnder: Word): Byte;
var
  RV: Byte;
begin
  if nEnder=$E000 then begin
    rv := $FF;
    if (GetAsyncKeyState(VK_3) and $8000)<>0       then rv  := rv and $7F;
    if (GetAsyncKeyState(VK_4) and $8000)<>0       then rv  := rv and $BF;
    if (GetAsyncKeyState(VK_LEFT) and $8000)<>0    then rv  := rv and $DF;
    if (GetAsyncKeyState(VK_RIGHT) and $8000)<>0   then rv  := rv and $EF;
    if (GetAsyncKeyState(VK_CONTROL) and $8000)<>0 then rv  := rv and $F7;
    if (GetAsyncKeyState(VK_3) and $8000)<>0       then rv  := rv and $FB;
    if (GetAsyncKeyState(VK_SHIFT) and $8000)<>0     then rv  := rv and $FD;
    if (GetAsyncKeyState(VK_MENU) and $8000)<>0     then rv  := rv and $FE;
    FroggerGetByte := rv;
    exit
  end;

  if nEnder=$E002 then begin
    rv := $FF;
    if (GetAsyncKeyState(VK_1) and $8000)<>0     then rv  := rv and $7F;
    if (GetAsyncKeyState(VK_2) and $8000)<>0     then rv  := rv and $BF;
    if (GetAsyncKeyState(VK_A) and $8000)<>0     then rv  := rv and $CF;
    if (GetAsyncKeyState(VK_D) and $8000)<>0     then rv  := rv and $EF;
    if (GetAsyncKeyState(VK_TAB) and $8000)<>0     then rv  := rv and $F7;
    if (GetAsyncKeyState(VK_C) and $8000)<>0     then rv  := rv and $FB;
    FroggerGetByte := rv;
    exit
  end;

  if nEnder=$E004 then begin
    rv := $FF;
    if (GetAsyncKeyState(VK_DOWN) and $8000)<>0 then rv  := rv and $BF;
    if (GetAsyncKeyState(VK_UP) and $8000)<>0   then rv  := rv and $EF;
    if (GetAsyncKeyState(VK_K) and $8000)<>0    then rv  := rv and $FE;
    FroggerGetByte := rv;
    exit
  end;

  FroggerGetByte := aZ80Mem[nEnder];
end;


function FroggerInByte(nEnder: Word): Byte;
var
  RV: Byte;
begin
  FroggerInByte := $FF;
end;

procedure FroggerOutByte(nEnder, nValue: Word);
begin
end;

procedure FroggerCreateScreen;
var
  nChar, nSprite, nEnder, i, j, nty, x, y, c, nDeltaY: LongInt;
  nY, nSX, nSY, nColor, nTotalX, nOffSetValue, nScanLine, nPos, nShift: LongInt;
begin
  FillSurface(0);

  for y := 0 to 31 do begin
    if true then begin
      nY := (31-Y);
    end
    else begin
      nY := Y;
    end;
    nSY := nY*8;
    nShift := aZ80Mem[$B000+2*nY];
    nShift := ((nShift shl 4) and $F0) or ((nShift shr 4) and $0F);

    nColor := (aZ80Mem[$B000+2*nY+1])*4+10;
    if nY<17 then nColor := nColor+32;

    for x := 0 to 31 do begin
      if true then
        nOffSetValue := aZ80Mem[oROMSInfo.nVRAM+(31-x)*32+nY]
      else
        nOffSetValue := aZ80Mem[oROMSInfo.nVRAM+x*32+nY];

      if (nOffSetValue<>16) or (nY<17) then begin
        nSX := (x*8+nShift) mod 256;
        if (nSX>=8) and (nSX<(256-8)) then
          PutNoTransSprite(nSX, nSY, nColor, aCharSet^[nOffSetValue]);
      end;
    end;
  end;


  nEnder := $B05F-3;
  while nEnder>=$B040 do begin
    if aZ80Mem[nEnder+3]<>0 then begin
      X := aZ80Mem[nEnder];
      X := ((X shl 4) and $f0) or ((X shr 4) and $0f);
      Y := aZ80Mem[nEnder+3];
      nColor := 4*(aZ80Mem[nEnder+2])+10;
      nSprite := aZ80Mem[nEnder+1] and $3F;
      xPutSprite(X, Y, nColor, 0, aSprites^[nSprite]);
    end;
    nEnder := nEnder-4;
  end;

end;


procedure FroggerInterrupt;
begin
  FroggerCreateScreen;

  if lDoubleScreen then
    CopySurfaceToScreen2x(frmGameScreen.Canvas.Handle)
  else
    CopySurfaceToScreen(frmGameScreen.Canvas.Handle);

  if oROMSInfo.nNMIEnable<>0 then begin
    if aZ80Mem[oROMSInfo.nNMIEnable]<>0 then begin
      aProcs[1].nPendingNMI := 1;
    end
    else begin
      aProcs[1].nPendingIRQ := $01000000;
    end;
  end;
end;


end.
