unit UGameScr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TfrmGameScreen = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    lCanDraw: Boolean;
    lCanClose: Boolean;
    procedure CreateDIB;
    procedure DestroyDIB;
    procedure ExecuteGame;
  end;

var
  frmGameScreen: TfrmGameScreen;

implementation

{$R *.DFM}

uses
  UDIBSurf, UZ80, UZ80Var;

procedure TfrmGameScreen.CreateDIB;
var
  nScreen: HDC;
  I: Integer;
  App_Palette: TMyLogPalette;
  aNewHPalette: HPalette;
begin
  App_Palette.palVersion    := $0300;
  App_Palette.palNumEntries := 256;

  nScreen := GetDC(0);
  GetSystemPaletteEntries(nScreen, 0  ,10, App_Palette.palEntry);
  GetSystemPaletteEntries(nScreen, 246, 10, App_Palette.palEntry[246]);
  ReleaseDC(0, nScreen);

  for i := 0 to 235 do begin
    App_Palette.palEntry[10+i].peFlags := pc_Reserved;
    App_Palette.palEntry[10+i].peRed   := aPalette[i].R;
    App_Palette.palEntry[10+i].peGreen := aPalette[i].G;
    App_Palette.palEntry[10+i].peBlue  := aPalette[i].B;
  end;

  aNewHPalette := CreatePalette(PLogPalette(@App_Palette)^);
  CreateDIBSurf(aNewHPalette, 256, 288);
  
  lCanDraw := true;
end;

procedure TfrmGameScreen.DestroyDIB;
begin
  lCanDraw := false;
  DestroyDIBSurf;
end;

procedure TfrmGameScreen.FormCreate(Sender: TObject);
begin
  lCanDraw := false;
end;

procedure TfrmGameScreen.ExecuteGame;
begin
  lStopEmulation := false;
  while not lStopEmulation do begin
    EvalInstr(1);
  end;
end;

procedure TfrmGameScreen.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if lCanClose then
    Action := CAFREE
  else
    Action := CANONE;
end;

procedure TfrmGameScreen.FormPaint(Sender: TObject);
begin
  Brush.Color := Color;
  Canvas.FillRect(ClientRect);

  if lDoubleScreen then
    CopySurfaceToScreen2x(frmGameScreen.Canvas.Handle)
  else
    CopySurfaceToScreen(frmGameScreen.Canvas.Handle);
end;

end.
