unit UInvader;

interface

procedure InvaderPutByte(nEnder, nValue: Word); pascal;
function InvaderGetByte(nEnder: Word): Byte; pascal;
function InvaderInByte(nPort: Word): Byte; pascal;
procedure InvaderOutByte(nEnder, nValue: Word); pascal;
procedure InvaderInterrupt; pascal;  

implementation

uses
  Classes, Windows, Forms, UDIBSurf, UZ80Var, UZ80, UGameScr, USprite, SysUtils;

const
  MEMORY        = 42;
  bBitmap: Byte = 0;
  bBitmapPrevious: Byte = 0;
  bShiftValue: Byte = 0;
  bSound1: Byte = 0;
  bSound2: Byte = 0;
  nIntCont: LongInt = 0;

procedure InvaderPutByte(nEnder, nValue: Word); pascal;
var
  c: Byte;
  b,  x, y: Integer;
begin
  if (nEnder<$2000) then exit;
  if (nEnder>=$4000) and (nEnder<=$5FFF) then exit;
  Byte(aZ80Mem[nEnder]) := nValue;

  if (nEnder>$23ff) then begin
    x := (nEnder-$2400) shr 5;
    y := (nEnder-$2400) and $1f;
    c := 7;
    if (y<8) then c:= 3;
    if (y>23) and (y<28) then c:= 1;
    for b:= 0 to 7 do begin
      if (nValue and $01)<>0 then begin
        SetPixelSafe(x, 255-((y shl 3)+b), c)
      end
      else
        SetPixelSafe(x, 255-((y shl 3)+b), 0);
      nValue := nValue shr 1;
    end;
    lDraw := true;
  end;
end;


function InvaderGetByte(nEnder: Word): Byte; pascal;
begin
 InvaderGetByte := aZ80Mem[nEnder];
end;

function InvaderInByte(nPort: Word): Byte;  pascal;
var
  wValue: Word;
  nValue: Byte;
begin
  case (nPort and $FF) of
    1: begin
      nValue := $81;
      if (GetAsyncKeyState(VK_1) and $8000)<>0       then nValue := nValue or $04;
      if (GetAsyncKeyState(VK_2) and $8000)<>0       then nValue := nValue or $02;
      if (GetAsyncKeyState(VK_3) and $8000)<>0       then nValue := nValue and (not $01);
      if (GetAsyncKeyState(VK_LEFT) and $8000)<>0    then nValue := nValue or $20;
      if (GetAsyncKeyState(VK_RIGHT) and $8000)<>0   then nValue := nValue or $40;
      if (GetAsyncKeyState(VK_CONTROL) and $8000)<>0 then nValue := nValue or $10;
      InvaderInByte := nValue;
    end;
    2: begin
       nValue := $0;
       if (GetAsyncKeyState(VK_T) and $8000)<>0       then nValue := nValue or $04;
       if (GetAsyncKeyState(VK_P) and $8000)<>0       then nValue := nValue or $08;
       InvaderInByte := nValue;
    end;
    3: begin
      wValue := (bBitmap shl 8) or bBitmapPrevious;
      wValue := wValue shl bShiftValue;
      nValue := wValue shr 8;
      InvaderInByte := nValue;
    end
    else begin
      InvaderInByte := 0;
    end;
  end;
end;


procedure InvaderOutByte(nEnder, nValue: Word);  pascal;
begin
  case nEnder of
    2: bShiftValue := nValue;
    3: begin
      {$ifdef MIX}
      if ((nValue and $01)<>0) and (((not bSound1) and $01)<>0) then StartSound(Sound[0], 0, true);
      if (((not nValue) and $01)<>0) and ((bSound1 and $01)<>0) then StopSound(0);
      if ((nValue and $02)<>0) and ((( not bSound1) and $02)<>0) then StartSound(Sound[1], 1, true);
      if (((not nValue) and $02)<>0) and ((bSound1 and $02)<>0) then StopSound(1);
      if ((nValue and $04)<>0) and (((not bSound1) and $04)<>0) then StartSound(Sound[2], 2, true);
      if (((not nValue) and $04)<>0) and ((bSound1 and $04)<>0) then StopSound(2);
      if ((nValue and $08)<>0) and (((not bSound1) and $08)<>0) then StartSound(Sound[3], 3, true);
      if (((not nValue) and $08)<>0) and (( bSound1 and $08)<>0) then StopSound(3);
      {$endif}
      bSound1 := nValue;
    end;
    4: begin
      bBitmapPrevious := bBitmap;
      bBitmap := nValue;
    end;
    5: begin
      {$ifdef MIX}
      if ((nValue and $01)<>0) and (((not bSound2) and $01)<>0) then StartSound(Sound[4], 4, false);
      if ((nValue and $02)<>0) and (((not bSound2) and $02)<>0) then StartSound(Sound[5], 5, false);
      if ((nValue and $04)<>0) and (((not bSound2) and $04)<>0) then StartSound(Sound[6], 6, false);
      if ((nValue and $08)<>0) and (((not bSound2) and $08)<>0) then StartSound(Sound[7], 7, false);
      if ((nValue and $10)<>0) and (((not bSound2) and $10)<>0) then StartSound(Sound[8], 7, true);
      if (((not nValue) and $10)<>0) and (( bSound2 and $08)<>0) then StopSound(7);
      {$endif}
      bSound2 := nValue;
    end;
  end;
end;


procedure InvaderInterrupt;  pascal;
begin
  Inc(nIntCont);
  if (nIntCont mod 2)=0 then begin
    aProcs[1].nPendingIRQ := $000000D7;
  end
  else begin
    aProcs[1].nPendingIRQ := $000000CF;
  end;

  if lDraw then begin
    lDraw := false;
    if lDoubleScreen then
      CopySurfaceToScreen2x(frmGameScreen.Canvas.Handle)
    else
      CopySurfaceToScreen(frmGameScreen.Canvas.Handle);
  end;
  Application.ProcessMessages;
end;


end.
