unit
  Uladybug;

interface

uses
  UMAMEChr, Classes, Windows, Forms, UDIBSurf, UZ80Var, UZ80, UGameScr, USprite, SysUtils;


  procedure LadyBugCreateScreen;
  function  LadyBugGetByte(nEnder: Word): Byte; pascal;
  procedure LadyBugPutByte(nEnder, nValue: Word); pascal;
  function LadyBugInByte(nPort: Word): Byte; pascal;
  procedure LadyBugOutByte(nPort, nValue: Word); pascal;
  procedure LadyBugInterrupt; pascal;
  procedure LadyBugInitDriver(aGraph: PMemory);
  procedure LadyBugDestroyDriver;
  procedure LadyBugShowCharSet(var nQtd: Integer; var aGFX: PArrayGFXElement);



implementation

var
  aSpriteGFX: array[0..2] of PGFXElement;
  nContInt: Word;

const
    oLadyBugColorProm: array[0..63] of byte=
      ((* palette *)
       $F5,$90,$41,$54,$94,$11,$80,$65,$05,$D4,$01,$00,$B1,$A0,$00,$F5,
       $04,$B1,$00,$15,$11,$25,$90,$D0,$A0,$90,$15,$84,$B5,$04,$04,$04,
       (* sprite color lookup table *)
       $00,$59,$33,$B8,$00,$D4,$A3,$8D,$00,$2C,$63,$DD,$00,$22,$38,$1D,
       $00,$93,$3A,$DD,$00,$E2,$38,$DD,$00,$82,$3A,$D8,$00,$22,$68,$1D);

    oLadyBugCharLayout: TGfxLayout =
      (width:8;
       height:8;        (* 8*8 characters *)
       total:512;       (* 512 characters *)
       planes:2;        (* 2 bits per pixel *)
       planeoffset:(0, 512*8*8, 0, 0, 0, 0, 0, 0);    (* the two bitplanes are separated *)
       xoffset:(7,6,5,4,3,2,1,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0);
       yoffset:(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0);
       charincrement: 8*8);  (* every char takes 8 consecutive bytes *)

    oLadyBugSpriteLayout: TGfxLayout =
      (width:16;
       height:16;       (* 16*16 sprites *)
       total:128;       (* 128 sprites *)
       planes:2;        (* 2 bits per pixel *)
       planeoffset:(1,0,0,0,0,0,0,0); (* the two bitplanes are packed in two consecutive bits *)
       xoffset:(0, 2, 4, 6, 8, 10, 12, 14,
                8*16+0, 8*16+2, 8*16+4, 8*16+6, 8*16+8, 8*16+10, 8*16+12, 8*16+14,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0);
       yoffset:(23*16, 22*16, 21*16, 20*16, 19*16, 18*16, 17*16, 16*16,
                7*16, 6*16, 5*16, 4*16, 3*16, 2*16, 1*16, 0*16,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0);
       charincrement:64*8);          (* every sprite takes 64 consecutive bytes *)

    oLadyBugSpriteLayout2: TGfxLayout =
      (width:8;
       height:8;        (* 8*8 sprites *)
       total:512;       (* 512 sprites *)
       planes:2;        (* 2 bits per pixel *)
       planeoffset:(1,0,0,0,0,0,0,0);(* the two bitplanes are packed in two consecutive bits *)
       xoffset:(0, 2, 4, 6, 8, 10, 12, 14,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0);
       yoffset:(7*16, 6*16, 5*16, 4*16, 3*16, 2*16, 1*16, 0*16,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0,
                0,0,0,0,0,0,0,0);
       charincrement:16*8);      (* every sprite takes 16 consecutive bytes *)

function LadyBugGetByte(nEnder: Word): Byte;
var
  RV: Byte;
begin
  if nEnder=$9000 then begin
    RV:= $FF;
    if (GetAsyncKeyState(VK_T) and $8000)<>0        then RV  := RV and $7F;
    if (GetAsyncKeyState(VK_2) and $8000)<>0        then RV  := RV and $BF;
    if (GetAsyncKeyState(VK_1) and $8000)<>0        then RV  := RV and $CF;
    if (GetAsyncKeyState(VK_LEFT) and $8000)<>0     then RV  := RV and ($FF xor $01);
    if (GetAsyncKeyState(VK_DOWN) and $8000)<>0     then RV  := RV and ($FF xor $02);
    if (GetAsyncKeyState(VK_RIGHT) and $8000)<>0    then RV  := RV and ($FF xor $04);
    if (GetAsyncKeyState(VK_UP) and $8000)<>0       then RV  := RV and ($FF xor $08);
    if (GetAsyncKeyState(VK_CONTROL) and $8000)<>0  then RV  := RV and ($FF xor $10);
    LadyBugGetByte := RV;
    Exit
  end;

  if nEnder=$9001 then begin
    RV := $FF;
    if (GetAsyncKeyState(VK_LEFT) and $8000)<>0     then RV  := RV and ($FF xor $01);
    if (GetAsyncKeyState(VK_DOWN) and $8000)<>0     then RV  := RV and ($FF xor $02);
    if (GetAsyncKeyState(VK_RIGHT) and $8000)<>0    then RV  := RV and ($FF xor $04);
    if (GetAsyncKeyState(VK_UP) and $8000)<>0       then RV  := RV and ($FF xor $08);
    if (GetAsyncKeyState(VK_CONTROL) and $8000)<>0  then RV  := RV and ($FF xor $10);

    nContInt := aZ80Regs^.nTicks div 32;
    if (nContInt mod 2)=0 then begin
      RV  := RV and ($FF xor $20);
    end;

    case (nContInt mod 4) of
      0: RV  := RV and ($FF xor $00);
      1: RV  := RV and ($FF xor $40);
      2: RV  := RV and ($FF xor $80);
      3: RV  := RV and ($FF xor $C0);
    end;

    LadyBugGetByte := RV;
    Exit
  end;

  if nEnder=$9002 then begin
    RV := $04 or { score with 10 letters }
          $08 or { rack test off }
          $10 or { freeze off }
          $40 or { free play = off }
          $80;   { lives = 3 }  
    LadyBugGetByte := RV;
    Exit
  end;

  if nEnder=$9003 then begin
    RV:= $FF;
    LadyBugGetByte := RV;
    Exit
  end;

  LadyBugGetByte := aZ80Mem^[nEnder];
end;

procedure LadyBugPutByte(nEnder, nValue: Word);
begin
  aZ80Mem^[nEnder] := nValue
end;

procedure LadyBugOutByte(nPort, nValue: Word);
begin
end;

function LadyBugInByte(nPort: Word): Byte;
begin
  LadyBugInByte := $FF;
end;

procedure LadyBugCreateScreen;
var
  I, nOffs, nSX, nSY, X: Integer;
  nFlip, nSprite, nColor: Byte;
  aScroll: array[0..31] of Integer;
begin
  FillSurface(0);

  for nOffs := 0 to 31 do begin
    nSX := nOffs mod 4;
    nSY := nOffs div 4;
    aScroll[nOffs] := aZ80Mem^[oROMSInfo.nVRAM+32*nSX+nSY];
  end;

  for nOffs := $3FF downto 0 do begin
    nSX := nOffs mod 32;
    nSY := nOffs div 32;
    nSprite := aZ80Mem^[oROMSInfo.nVRAM+nOffs]+
               32*(aZ80Mem^[oROMSInfo.nAttrRAM+nOffs] and $08);
    nColor := (aZ80Mem^[oROMSInfo.nAttrRAM+nOffs] and $07)*4;
    X := nSX*8-aScroll[nSY];
    if X<0 then X := X+256;
    if oROMSInfo.nDrvTag=0 then begin
      xPutColorSprite(8*nSY, 255-X, nColor, 0, aSpriteGFX[0]^.gfxdata^[nSprite]);
    end
    else begin
      xPutColorSprite(X, 8*nSY, nColor, 0, aSpriteGFX[0]^.gfxdata^[nSprite]);
    end;
  end;

  nOffs := $400-2*$40;
  while nOffs>=2*$40 do begin
    nOffs := nOffs - $40;
    I := 0;
    while (I<$40) and (aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I]<>0) do Inc(I, 4);
    while I>0 do begin
      I := I-4;
      if (aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I] and $80)<>0 then begin
        if (aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I] and $40)<>0 then begin
          nSprite := (aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I+1] shr 2) +
                     4*(aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I+2] and $10);
          nColor := 32+(aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I+2] and $0F)*4;

          nFlip := 0;
          if (aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I] and $20)<>0 then nFlip := nFlip or $40;
          if (aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I] and $10)<>0 then nFlip := nFlip or $80;
          nSX := aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I+3]+8;
          nSY := nOffs div 4 - 8 + (aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I] and $0F);
          if oROMSInfo.nDrvTag=0 then begin
            xPutColorSprite(nSY, 255-nSX, nColor, nFlip, aSpriteGFX[1]^.gfxdata^[nSprite]);
          end
          else begin
            xPutColorSprite(nSX, nSY, nColor, nFlip, aSpriteGFX[1]^.gfxdata^[nSprite]);
          end;
        end
        else begin
          nSprite := aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I+1]+
                     4*(aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I+2] and $10);
          nColor := 32+(aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I+2] and $0F)*4;
          nFlip := 0;
          if (aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I] and $20)<>0 then nFlip := nFlip or $40;
          if (aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I] and $10)<>0 then nFlip := nFlip or $80;
          nSX := aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I+3]+8;
          nSY := nOffs div 4+(aZ80Mem^[oROMSInfo.nSpriteRAM+nOffs+I] and $0F);
          if oROMSInfo.nDrvTag=0 then begin
            xPutColorSprite(nSY, 255-nSX, nColor, nFlip, aSpriteGFX[2]^.gfxdata^[nSprite]);
          end
          else begin
            xPutColorSprite(nSX, nSY, nColor, nFlip, aSpriteGFX[2]^.gfxdata^[nSprite]);
          end;
        end;
      end;
    end;
  end;
end;



procedure LadyBugInterrupt;
begin
  Inc(nContInt);
  LadyBugCreateScreen;

  if lDoubleScreen then
    CopySurfaceToScreen2x(frmGameScreen.Canvas.Handle)
  else
    CopySurfaceToScreen(frmGameScreen.Canvas.Handle);

  if (GetAsyncKeyState(VK_3) and $8000)<>0  then begin
    aProcs[1].nPendingNMI := 1;
  end;

  if (GetAsyncKeyState(VK_4) and $8000)<>0  then begin
    aProcs[1].nPendingIRQ := $000000FF;
  end;
end;

procedure LadyBugInitDriver(aGraph: PMemory);
var
  oMachine: TMachine;
  Bit0, Bit1, Bit2, Bit3, I: Integer;
begin
  nContInt := 0;
  if oROMSInfo.nDrvTag=0 then begin
    oMachine.orientation := ORIENTATION_SWAP_XY or ORIENTATION_FLIP_Y;
  end
  else begin
    oMachine.orientation := 0;
  end;

  aSpriteGFX[0] := DecodeGFX('CharSet (8x8)', 0,
                             @oMachine, @aGraph^[$0000], @oLadyBugCharLayout);
  aSpriteGFX[1] := DecodeGFX('Sprite Set #1 (16x16)', 32,
                             @oMachine, @aGraph^[$2000], @oLadyBugSpriteLayout);
  aSpriteGFX[2] := DecodeGFX('Sprite Set #2 (8x8)', 32,
                             @oMachine, @aGraph^[$2000], @oLadyBugSpriteLayout2);

  for i := 0 to 31 do begin
    bit1 := (($FF xor oLadyBugColorPROM[i])  shr  0)  and  $01;
    bit2 := (($FF xor oLadyBugColorPROM[i])  shr  5)  and  $01;
    aPalette[i].R := $47 * bit1 + $97 * bit2;

    bit1 := (($FF xor oLadyBugColorPROM[i])  shr  2)  and  $01;
    bit2 := (($FF xor oLadyBugColorPROM[i])  shr  6)  and  $01;
    aPalette[i].G := $47 * bit1 + $97 * bit2;

    bit1 := (($FF xor oLadyBugColorPROM[i])  shr  4)  and  $01;
    bit2 := (($FF xor oLadyBugColorPROM[i])  shr  7)  and  $01;
    aPalette[i].B := $47 * bit1 + $97 * bit2;
  end;

  for i := 0 to 7 do begin
    aColorLookUpTable[4*i+0] := 0;
    aColorLookUpTable[4*i+1] := i+$08;
    aColorLookUpTable[4*i+2] := i+$10;
    aColorLookUpTable[4*i+3] := i+$18;
  end;

  for i := 0 to 31 do begin
    bit0 := (oLadyBugColorPROM[i + 32]  shr  3)  and  $01;
    bit1 := (oLadyBugColorPROM[i + 32]  shr  2)  and  $01;
    bit2 := (oLadyBugColorPROM[i + 32]  shr  1)  and  $01;
    bit3 := (oLadyBugColorPROM[i + 32]  shr  0)  and  $01;
    aColorLookUpTable[i + 4 * 8] := 1 * bit0 + 2 * bit1 + 4 * bit2 + 8 * bit3;

    bit0 := (oLadyBugColorPROM[i + 32]  shr  7)  and  $01;
    bit1 := (oLadyBugColorPROM[i + 32]  shr  6)  and  $01;
    bit2 := (oLadyBugColorPROM[i + 32]  shr  5)  and  $01;
    bit3 := (oLadyBugColorPROM[i + 32]  shr  4)  and  $01;
    aColorLookUpTable[i + 4 * 16] := 1 * bit0 + 2 * bit1 + 4 * bit2 + 8 * bit3;
  end;
end;

procedure LadyBugDestroyDriver;
begin
  FreeGFX(aSpriteGFX[0]);
  FreeGFX(aSpriteGFX[1]);
  FreeGFX(aSpriteGFX[2]);
end;

procedure LadyBugShowCharSet(var nQtd: Integer; var aGFX: PArrayGFXElement);
begin
  nQtd := 3;
  aGFX := @aSpriteGFX;
end;


end.
