unit
  UPacman;

interface

uses
  UMAMEChr, Classes, Windows, Forms, UDIBSurf, UZ80Var, UZ80, UGameScr, USprite, SysUtils;


  function  PacmanGetByte(nEnder: Word): Byte; pascal;
  procedure PacmanPutByte(nEnder, nValue: Word); pascal;
  function  PacmanInByte(nPort: Word): Byte; pascal;
  procedure PacmanOutByte(nEnder, nValue: Word); pascal;
  procedure PacmanInterrupt; pascal;
  procedure PacmanShowCharSet(var nQtd: Integer; var aGFX: PArrayGFXElement);
  procedure PacmanInitDriver(aGraph: PMemory);
  procedure PacmanCreateScreen;
  procedure PacmanDestroyDriver;



implementation

const
  PACMAN_IN0 = $5000;
  PACMAN_IN1 = $5040;
  PACMAN_DSW = $5080;
  aPacmanColorPROM: array[0..15] of byte =
    ($00,$07,$66,$EF,$00,$F8,$EA,$6F,$00,$3F,$00,$C9,$38,$AA,$AF,$F6);
  aPacmanLookUpTable: array[0..127] of byte =
    ($00,$00,$00,$00,$00,$0F,$0B,$01,$00,$00,$00,$00,$00,$0F,$0B,$03,
     $00,$00,$00,$00,$00,$0F,$0B,$05,$00,$00,$00,$00,$00,$0F,$0B,$07,
     $00,$00,$00,$00,$00,$0B,$01,$09,$00,$00,$00,$00,$00,$00,$00,$00,
     $00,$00,$00,$00,$00,$00,$00,$00,$00,$0F,$00,$0E,$00,$01,$0C,$0F,
     $00,$0E,$00,$0B,$00,$0C,$0B,$0E,$00,$0C,$0F,$01,$00,$00,$00,$00,
     $00,$01,$02,$0F,$00,$07,$0C,$02,$00,$09,$06,$0F,$00,$0D,$0C,$0F,
     $00,$05,$03,$09,$00,$0F,$0B,$00,$00,$0E,$00,$0B,$00,$0E,$00,$0B,
     $00,$00,$00,$00,$00,$0F,$0E,$01,$00,$0F,$0B,$0E,$00,$0E,$00,$0F);

  oPacmanCharLayout: TGfxLayout =
    (width:8;
     height:8;  (* 8*8 characters *)
     total:256; (* 256 characters *)
     planes:2;  (* 2 bits per pixel *)
     planeoffset:(0,4,0,0,0,0,0,0);  (* the two bitplanes for 4 pixels are packed into one byte *)
     xoffset:(7*8, 6*8, 5*8, 4*8, 3*8, 2*8, 1*8, 0*8,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0);
     yoffset:(8*8+0, 8*8+1, 8*8+2, 8*8+3, 0, 1, 2, 3,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0);
     charincrement:16*8);

  oPacmanSpriteLayout: TGfxLayout =
    (width:16;
     height:16;	(* 16*16 sprites *)
     total:64;	(* 64 sprites *)
     planes:2;	(* 2 bits per pixel *)
     planeoffset:(0,4,0,0,0,0,0,0); (* the two bitplanes for 4 pixels are packed into one byte *)
     xoffset:(39*8,38*8,37*8,36*8,35*8,34*8,33*8,32*8,
              7*8, 6*8, 5*8, 4*8, 3*8, 2*8, 1*8, 0*8,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0);
     yoffset:(8*8,8*8+1,8*8+2,8*8+3,16*8+0,16*8+1,16*8+2,16*8+3,
              24*8+0, 24*8+1, 24*8+2, 24*8+3, 0, 1, 2, 3,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0,
              0,0,0,0,0,0,0,0);
     charincrement:64*8);(* every sprite takes 64 bytes *)

  var
    nIM2AddrLo: Integer;
    aSpriteGFX: array[0..1] of PGFXElement;


function  PacmanInByte(nPort: Word): Byte;
begin
  PacmanInByte := 0;
end;


procedure PacmanOutByte(nEnder, nValue: Word);
begin
  case nEnder and $FF of
    $00: begin
      nIM2AddrLo := nValue and $FF;
    end;
  end;
end;

function PacmanGetByte(nEnder: Word): Byte;
var
  RV: Byte;
begin

  if nEnder=PACMAN_IN0 then begin
    rv := $FF;
    if (GetAsyncKeyState(VK_UP) and $8000)<>0     then rv  := rv and not $01;
    if (GetAsyncKeyState(VK_LEFT) and $8000)<>0   then rv  := rv and not $02;
    if (GetAsyncKeyState(VK_RIGHT) and $8000)<>0  then rv  := rv and not $04;
    if (GetAsyncKeyState(VK_DOWN) and $8000)<>0   then rv  := rv and not $08;
    rv := rv or $10; { }
    if (GetAsyncKeyState(VK_3) and $8000)<>0      then rv  := rv and not $20;
    if (GetAsyncKeyState(VK_4) and $8000)<>0      then rv  := rv and not $40;
    if (GetAsyncKeyState(VK_5) and $8000)<>0      then rv  := rv and not $80;
    PacmanGetByte := rv;
    exit
  end;

  if nEnder=PACMAN_IN1 then begin
    rv := $FF;
    if (GetAsyncKeyState(VK_UP) and $8000)<>0     then rv  := rv and not $01;
    if (GetAsyncKeyState(VK_LEFT) and $8000)<>0   then rv  := rv and not $02;
    if (GetAsyncKeyState(VK_RIGHT) and $8000)<>0  then rv  := rv and not $04;
    if (GetAsyncKeyState(VK_DOWN) and $8000)<>0   then rv  := rv and not $08;
    rv := rv or $10; { }
    if (GetAsyncKeyState(VK_1) and $8000)<>0      then rv  := rv and not $20;
    if (GetAsyncKeyState(VK_2) and $8000)<>0      then rv  := rv and not $40;
    rv := rv and not $80; { }
    PacmanGetByte := rv;
    exit
  end;

  if nEnder=PACMAN_DSW then begin
    rv := $FF;
    PacmanGetByte := rv;
    exit
  end;



  {
  if nEnder=Pacman_IN1_PORT then begin
    rv := $10;
    if (GetAsyncKeyState(VK_2) and $8000)<>0     then rv  := rv or Pacman_IN1_2P_START;
    if (GetAsyncKeyState(VK_1) and $8000)<>0     then rv  := rv or Pacman_IN1_1P_START;
    PacmanGetByte := rv;
    exit
  end;

  if nEnder=Pacman_DSW_PORT then begin
    rv := $00;
    PacmanGetByte := $FF;
    exit
  end;
  }


  PacmanGetByte := aZ80Mem[nEnder];
end;


procedure PacmanPutByte(nEnder, nValue: Word);
begin
  if (nEnder>=$C000) and (nEnder<=$C7EF) then nEnder := nEnder-$8000;

  aZ80Mem[nEnder] := nValue
end;


procedure PacmanCreateScreen;
var
  nSprite, nOffSetValue, mx, my, sx, sy, flipx, flipy, offs: Integer;
  nFlip: Byte;
  nColor: Integer;
begin
  FillSurface(0);
  for offs := 1023 downto 0 do begin
    nSprite := aZ80Mem[oROMSInfo.nVRAM+offs];
    {if nSprite=16 then continue;}

    mx := offs mod 32;
    my := offs div 32;

    if (my <= 1) then begin
      sx := 34+my;
      sy := mx;
    end
    else if (my>=30) then begin
      sx := my-30;
      sy := mx;
    end
    else begin
      sy := my;
      sx := mx + 2;
    end;

    if false then begin
      sx := 31-sx;
      sy := 31-sy;
    end;
    nColor := (aZ80Mem[oROMSInfo.nAttrRAM+offs] and $1F)*4;
    if sy<=1 then continue;
    if sy>=30 then continue;

    xPutColorNoTransSprite(8*(31-sy), 8*sx, nColor, 0, aSpriteGFX[0]^.gfxdata^[nSprite]);
  end;

  offs := 14;
  while offs>=0 do begin
    nSprite := aZ80Mem[oROMSInfo.nSpriteRAM+offs] shr 2;
    if nSprite<>0 then begin
      nColor := 4*(aZ80Mem[oROMSInfo.nSpriteRAM+offs+1] and $1F);
      flipx := aZ80Mem[oROMSInfo.nSpriteRAM+offs] and 2;
      flipy := aZ80Mem[oROMSInfo.nSpriteRAM+offs] and 1;
      sx := aZ80Mem[$5060+offs];
      sy := aZ80Mem[$5061+offs];
      nFlip := 0;
      if flipy<>0 then nFlip := nFlip or $40;
      if flipx<>0 then nFlip := nFlip or $80;
      if (sx>0) and (sy>0) and ((255-sx)<(255-16)) and ((271-sy)<(287-16)) then
        xPutColorSprite(255-sx, 271-sy, nColor, nFlip, aSpriteGFX[1]^.gfxdata^[nSprite]);
    end;
    Dec(offs, 2);
  end;
end;


procedure PacmanInterrupt;
begin
  PacmanCreateScreen;

  if lDoubleScreen then
    CopySurfaceToScreen2x(frmGameScreen.Canvas.Handle)
  else
    CopySurfaceToScreen(frmGameScreen.Canvas.Handle);

  if aZ80Mem[oROMSInfo.nNMIEnable]=0 then begin
    aProcs[1].nPendingIRQ := $01000000;
  end
  else begin
    aProcs[1].nPendingIRQ := nIM2AddrLo;
  end;
end;





procedure PacmanInitDriver(aGraph: PMemory);
var
  oMachine: TMachine;
  Bit0, Bit1, Bit2, I: Integer;
begin
  oMachine.orientation := 0;

  aSpriteGFX[0] := DecodeGFX('Char Set (8x8)', 0,
                             @oMachine, @aGraph^[$0000], @oPacmanCharLayout);
  aSpriteGFX[1] := DecodeGFX('Sprite Set (16x16)', 0,
                             @oMachine, @aGraph^[$1000], @oPacmanSpriteLayout);

  for i := 0 to 15 do begin
    bit0 := (aPacmanColorPROM[i]  shr  0)  and  $01;
    bit1 := (aPacmanColorPROM[i]  shr  1)  and  $01;
    bit2 := (aPacmanColorPROM[i]  shr  2)  and  $01;
    aPalette[i].R := $21 * bit0 + $47 * bit1 + $97 * bit2;

    bit0 := (aPacmanColorPROM[i]  shr  3)  and  $01;
    bit1 := (aPacmanColorPROM[i]  shr  4)  and  $01;
    bit2 := (aPacmanColorPROM[i]  shr  5)  and  $01;
    aPalette[i].G := $21 * bit0 + $47 * bit1 + $97 * bit2;

    bit0 := 0;
    bit1 := (aPacmanColorPROM[i]  shr  6)  and  $01;
    bit2 := (aPacmanColorPROM[i]  shr  7)  and  $01;
    aPalette[i].B := $21 * bit0 + $47 * bit1 + $97 * bit2;
  end;

  for i := 0 to 127 do aColorLookUpTable[i] := aPacmanLookUpTable[i];
end;

procedure PacmanDestroyDriver;
begin
  FreeGFX(aSpriteGFX[0]);
  FreeGFX(aSpriteGFX[1]);
end;

procedure PacmanShowCharSet(var nQtd: Integer; var aGFX: PArrayGFXElement);
begin
  nQtd := 2;
  aGFX := @aSpriteGFX;
end;

end.