{0800-155566}

{$ALIGN OFF}
unit upasmul;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls, ComCtrls, udebug, usprset, ucharset, uz80dsm, Gauges;


type
  TDestroyDriver = procedure;
  TfrmEmulator = class(TForm)
    Panel1: TPanel;
    sbStart: TSpeedButton;
    cbDoubleScr: TCheckBox;
    cbDebug: TCheckBox;
    cbDrivers: TComboBox;
    lbGames: TListBox;
    lblDrivers: TLabel;
    lblGames: TLabel;
    sbReset: TSpeedButton;
    sbDSW: TSpeedButton;
    sbSprites: TSpeedButton;
    Bevel1: TBevel;
    sbCart: TSpeedButton;
    StatusBar1: TStatusBar;
    cbBreakPoint: TCheckBox;
    sbAddBreak: TSpeedButton;
    sbDelBreak: TSpeedButton;
    cbBreak: TComboBox;
    sbDisasm: TSpeedButton;
    procedure sbStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbDebugClick(Sender: TObject);
    procedure cbDoubleScrClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbDriversChange(Sender: TObject);
    procedure lbGamesDrawItem(Control: TWinControl; Index: Integer;
      oRect: TRect; State: TOwnerDrawState);
    procedure lbGamesDblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbDriversDrawItem(Control: TWinControl; Index: Integer;
      oRect: TRect; State: TOwnerDrawState);
    procedure sbResetClick(Sender: TObject);
    procedure sbCharSetsClick(Sender: TObject);
    procedure sbSpritesClick(Sender: TObject);
    procedure sbCartClick(Sender: TObject);
    procedure cbBreakPointClick(Sender: TObject);
    procedure sbAddBreakClick(Sender: TObject);
    procedure sbDisasmClick(Sender: TObject);
    procedure cbBreakDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure sbDelBreakClick(Sender: TObject);
  private
    { Private declarations }
    nTime: LongInt;
    lDebug: Boolean;
    aString: TStringList;
    oDestroyDriver: TDestroyDriver;
    {oDebug: System.Text;}
    procedure FillGameList;
  public
    { Public declarations }
  end;

var
  frmEmulator: TfrmEmulator;

implementation

uses
  UStrings, UGameScr, UDIBSurf, UZ80, ULoadROM, UZ80Var,
  {Drivers}
  UInvader, UGalax, UFrogger, USpect, UColeco, UPhoenix, UScramb,
  ULadyBug, UPooyan, UPacman, UGBeret,
  ubrkpnt;
{$R *.DFM}


procedure ExtractTitle(cFileName: String; var cTitle, cDriver: String);
var
  F: Text;
  cLine: String;
begin
  FileMode := 0;

  cTitle := cFileName;
  cDriver := cFileName;

  Assign(F, cFileName);
  Reset(F);
  while not Eof(F) do begin
    Readln(F, cLine);
    if Copy(cLine, 1, 7)='#TITLE=' then begin
      Delete(cLine, 1, 7);
      cTitle := cLine;
    end
    else if Upper(Copy(cLine, 1, 8))='#DRIVER=' then begin
      Delete(cLine, 1, 8);
      cDriver := cLine;
    end;
  end;
  Close(F);
end;


procedure TfrmEmulator.sbStartClick(Sender: TObject);
var
  nPos, I, J: Integer;
  cAux,
  cDriver,
  cFileName,
  cError: String;
  aGraph: PMemory;

  procedure EvalDebug;
  begin
    frmDebug.lblAF.Caption := ToHex(aZ80Regs^.AF.W, 4);
    frmDebug.lblBC.Caption := ToHex(aZ80Regs^.BC.W, 4);
    frmDebug.lblDE.Caption := ToHex(aZ80Regs^.DE.W, 4);
    frmDebug.lblHL.Caption := ToHex(aZ80Regs^.HL.W, 4);
    frmDebug.lblIX.Caption := ToHex(aZ80Regs^.IX.W, 4);
    frmDebug.lblIY.Caption := ToHex(aZ80Regs^.IY.W, 4);
    frmDebug.lblSP.Caption := ToHex(aZ80Regs^.SP.W, 4);
    frmDebug.lblPC.Caption := ToHex(aZ80Regs^.PC.W, 4);
    frmDebug.lblSFlag.Visible := (aZ80Regs^.AF.l and S_FLAG)<>0;
    frmDebug.lblZFlag.Visible := (aZ80Regs^.AF.l and Z_FLAG)<>0;
    frmDebug.lblHFlag.Visible := (aZ80Regs^.AF.l and H_FLAG)<>0;
    frmDebug.lblPFlag.Visible := (aZ80Regs^.AF.l and P_FLAG)<>0;
    frmDebug.lblNFlag.Visible := (aZ80Regs^.AF.l and N_FLAG)<>0;
    frmDebug.lblCFlag.Visible := (aZ80Regs^.AF.l and C_FLAG)<>0;
    frmDebug.lblBit5Flag.Visible := (aZ80Regs^.AF.l and $20)<>0;
    frmDebug.lblBit3Flag.Visible := (aZ80Regs^.AF.l and $08)<>0;
    frmDebug.EvalWatches;
  end;

  procedure EvalBreakPoints;
  var
    cAddr: String;
    nBrk: Integer;
  begin
    for nBrk := 0 to cbBreak.Items.Count-1 do begin
      cAddr := cbBreak.Items[nBrk];
      if HexToInt(cAddr)=aZ80Regs.PC.W then begin
        EvalDebug;
        ShowMessage('The instruction in address of the breakpoint ['+cAddr+'] is the next to be executed.');
        cbDebug.Checked := true;
        frmDebug.SetDebugState(STATE_PAUSED);
      end;
    end;
  end;

begin
  frmGameScreen.Top := Top;
  frmGameScreen.Left := Left+Width+2;
  nScrW := 256;
  nScrH := 256;
  nScrDX := 0;
  nScrDY := 0;

  if frmGameScreen.Visible then begin
    lStopEmulation := true;
    oROMSInfo.Free;
    sbStart.Caption := 'Start';
    sbReset.Enabled := false;
    sbSprites.Enabled := false;
    sbCart.Enabled := false;

    frmGameScreen.lCanClose := true;
    frmGameScreen.DestroyDIB;
    frmGameScreen.Hide;

    cbDrivers.Enabled := true;
    lbGames.Enabled := true;
    sbDisasm.Enabled := false;

    frmDisasm.ClearStruct;
  end
  else begin
    cbDrivers.Enabled := false;
    lbGames.Enabled := false;

    cError := lbGames.Items[lbGames.ItemIndex];
    nPos := Pos(#2, cError);
    if nPos=0 then begin
      ShowMessage('Error reading INI file!');
      lStopEmulation := true;
      oROMSInfo.Free;
      cbDrivers.Enabled := true;
      lbGames.Enabled := true;
      Exit
    end;

    Delete(cError, 1, nPos);

    oROMSInfo.LoadInfo(cError);

    frmGameScreen.Caption := oRomsInfo.cTitle+' ['+oRomsInfo.cDriver+']';

    aZ80Regs := @aProcs;
    FillChar(aProcs, SizeOf(aProcs), 0);
    aZ80Regs^.SP.W := $F000;
    oLoadCart := nil;
    oShowCharSet := nil;

    GetMem(aGraph, $20000);
    if not oROMSInfo.LoadRoms(ExtractFilePath(Application.ExeName), aZ80Mem, aGraph, cError) then begin
      ShowMessage('Failed when loading ROMS:'#13+cError);
      lStopEmulation := true;
      oROMSInfo.Free;
      cbDrivers.Enabled := true;
      lbGames.Enabled := true;
      Exit
    end;

    aZ80Regs^.nMaxRAM := oROMSInfo.nMaxDirectRead;
    aZ80Regs^.nMaxROM := oROMSInfo.nMaxROM;
    aProcs[1].nHalted := 0;
    aProcs[1].nIM := 0;
    aZ80Regs^.IFF1 := 0;
    aZ80Regs^.IFF2 := 0;

    oDestroyDriver := nil;
    if Upper(oRomsInfo.cDriver)='GALAXIAN' then begin
      oDestroyDriver := GalaxianDestroyDriver;
      oCreateScreen := GalaxianCreateScreen;
      aProcs[1].oGetByteFunc := GalaxianGetByte;
      aProcs[1].oPutByteFunc := GalaxianPutByte;
      aProcs[1].oOutByteFunc := InvaderOutByte;
      aProcs[1].oInByteFunc  := InvaderInByte;
      aProcs[1].oInterruptFunc := GalaxianInterrupt;
      aProcs[1].oMemory := aZ80Mem;

      aProcs[1].nNMIInt := oROMsInfo.nNMIAddr;

      if oRomsInfo.nDrvTag=$50 then begin
        Move(aGraph^[$3000], aGraph^[$0800], $800);
        Move(aGraph^[$3800], aGraph^[$1800], $800);
        Move(aGraph^[$4000], aGraph^[$0000], $800);
        Move(aGraph^[$4800], aGraph^[$1000], $800);
      end;

      GalaxianInitDriver;
      GalaxianCharSet(aGraph);
      nScrW := 224;
      nScrH := 256;
      nScrDX := 16;
    end
    else if Upper(oRomsInfo.cDriver)='LADYBUG' then begin
      oShowCharSet := LadyBugShowCharSet;
      oDestroyDriver := LadyBugDestroyDriver;
      oCreateScreen := LadyBugCreateScreen;
      aProcs[1].oGetByteFunc := LadyBugGetByte;
      aProcs[1].oPutByteFunc := LadyBugPutByte;
      aProcs[1].oOutByteFunc := LadyBugOutByte;
      aProcs[1].oInByteFunc  := LadyBugInByte;
      aProcs[1].oInterruptFunc := LadyBugInterrupt;
      aProcs[1].oMemory := aZ80Mem;
      aProcs[1].nNMIInt := oROMsInfo.nNMIAddr;
      LadyBugInitDriver(aGraph);
      if oROMSInfo.nDrvTag=0 then begin
        nScrW := 224-32;
        nScrH := 256-16;
        nScrDX := 32;
        nScrDY := 16;
      end
      else begin
        nScrW := 256-16;
        nScrH := 256-64;
        nScrDX := 8;
        nScrDY := 32;
      end;

    end
    else if Upper(oRomsInfo.cDriver)='FROGGER' then begin
      oDestroyDriver := GalaxianDestroyDriver;
      oCreateScreen := FroggerCreateScreen;
      aProcs[1].oGetByteFunc := FroggerGetByte;
      aProcs[1].oPutByteFunc := FroggerPutByte;
      aProcs[1].oOutByteFunc := FroggerOutByte;
      aProcs[1].oInByteFunc  := FroggerInByte;
      aProcs[1].oInterruptFunc := FroggerInterrupt;
      aProcs[1].oMemory := aZ80Mem;
      aProcs[1].nNMIInt := oROMsInfo.nNMIAddr;
      FroggerInitDriver;

      {
      if not GalaxianConvertColorPROM(oROMSInfo.cColorPROM, cError) then begin
        ShowMessage('Failed when loading Color PROM:'#13+cError);
        lStopEmulation := true;
        oROMSInfo.Free;
        cbDrivers.Enabled := true;
        lbGames.Enabled := true;
        Exit
      end;
      }
      GalaxianCharSet(aGraph);
      nScrW := 224;
      nScrH := 256;
      nScrDX := 16;
    end
    else if Upper(oRomsInfo.cDriver)='INVADERS' then begin
      aProcs[1].oGetByteFunc := InvaderGetByte;
      aProcs[1].oPutByteFunc := InvaderPutByte;
      aProcs[1].oOutByteFunc := InvaderOutByte;
      aProcs[1].oInByteFunc  := InvaderInByte;
      aProcs[1].oInterruptFunc := InvaderInterrupt;
      aProcs[1].oMemory := aZ80Mem;
      aProcs[1].nNMIInt := $10;
      nScrW := 256;
      nScrH := 256;
      nScrDX := 0;
    end
    else if Upper(oRomsInfo.cDriver)='PHOENIX' then begin
      aProcs[1].oGetByteFunc := PhoenixGetByte;
      aProcs[1].oPutByteFunc := PhoenixPutByte;
      aProcs[1].oOutByteFunc := PhoenixOutByte;
      aProcs[1].oInByteFunc  := PhoenixInByte;
      aProcs[1].oInterruptFunc := PhoenixInterrupt;
      aProcs[1].oMemory := aZ80Mem;
      aProcs[1].nNMIInt := oROMsInfo.nNMIAddr;

      PhoenixInitDriver;
      PhoenixCharSet(aGraph);
      oCreateScreen := PhoenixCreateScreen;
      nScrW := 256-48;
      nScrH := 256;
      nScrDX := 0;
    end
    else if Upper(oRomsInfo.cDriver)='SCRAMBLE' then begin
      oDestroyDriver := GalaxianDestroyDriver;
      aProcs[1].oGetByteFunc := ScrambleGetByte;
      aProcs[1].oPutByteFunc := ScramblePutByte;
      aProcs[1].oOutByteFunc := PhoenixOutByte;
      aProcs[1].oInByteFunc  := PhoenixInByte;
      aProcs[1].oInterruptFunc := GalaxianInterrupt;
      aProcs[1].oMemory := aZ80Mem;
      aProcs[1].nNMIInt := oROMsInfo.nNMIAddr;

      ScrambleInitDriver;
      GalaxianCharSet(aGraph);
      oCreateScreen := GalaxianCreateScreen;
      nScrW := 224;
      nScrH := 256;
      nScrDX := 16;
    end
    else if Upper(oRomsInfo.cDriver)='SPECTRUM' then begin
      aProcs[1].oGetByteFunc := SpectrumGetByte;
      aProcs[1].oPutByteFunc := SpectrumPutByte;
      aProcs[1].oOutByteFunc := SpectrumOutByte;
      aProcs[1].oInByteFunc  := SpectrumInByte;
      aProcs[1].oInterruptFunc := SpectrumInterrupt;
      aProcs[1].oMemory := aZ80Mem;
      aProcs[1].nNMIInt := $66;
      SpectrumInitDriver;
      oLoadCart := SpectrumLoadCart;
      nScrW := 256;
      nScrH := 192;
      nScrDX := 0;
    end
    else if Upper(oRomsInfo.cDriver)='COLECO' then begin
      aProcs[1].oGetByteFunc := ColecoGetByte;
      aProcs[1].oPutByteFunc := ColecoPutByte;
      aProcs[1].oOutByteFunc := ColecoOutByte;
      aProcs[1].oInByteFunc  := ColecoInByte;
      aProcs[1].oInterruptFunc := ColecoInterrupt;
      aProcs[1].oMemory := aZ80Mem;
      aProcs[1].nNMIInt := $66;
      ColecoInitDriver;
      oLoadCart := ColecoLoadCart;
      nScrW := 256;
      nScrH := 192;
      nScrDX := 0;
    end
    else if Upper(oRomsInfo.cDriver)='POOYAN' then begin
      oShowCharSet := PooyanShowCharSet;
      aProcs[1].oGetByteFunc := PooyanGetByte;
      aProcs[1].oPutByteFunc := PooyanPutByte;
      aProcs[1].oOutByteFunc := PooyanOutByte;
      aProcs[1].oInByteFunc  := PooyanInByte;
      aProcs[1].oInterruptFunc := PooyanInterrupt;
      aProcs[1].oMemory := aZ80Mem;
      aProcs[1].nNMIInt := $66;
      PooyanInitDriver(aGraph);
      oCreateScreen := PooyanCreateScreen;
      oDestroyDriver := PooyanDestroyDriver;
      nScrW := 256-32;
      nScrH := 256;
      nScrDX := 16;
    end
    else if Upper(oRomsInfo.cDriver)='PACMAN' then begin
      oShowCharSet := PacmanShowCharSet;
      aProcs[1].oGetByteFunc := PacmanGetByte;
      aProcs[1].oPutByteFunc := PacmanPutByte;
      aProcs[1].oOutByteFunc := PacmanOutByte;
      aProcs[1].oInByteFunc  := PacmanInByte;
      aProcs[1].oInterruptFunc := PacmanInterrupt;
      aProcs[1].oMemory := aZ80Mem;
      aProcs[1].nNMIInt := $66;
      PacmanInitDriver(aGraph);
      oCreateScreen := PacmanCreateScreen;
      oDestroyDriver := PacmanDestroyDriver;
      nScrW := 256-32;
      nScrH := 288;
      nScrDX := 16;
    end
    else if Upper(oRomsInfo.cDriver)='GBERET' then begin
      oShowCharSet := GreenBeretShowCharSet;
      aProcs[1].oGetByteFunc := GreenBeretGetByte;
      aProcs[1].oPutByteFunc := GreenBeretPutByte;
      aProcs[1].oOutByteFunc := GreenBeretOutByte;
      aProcs[1].oInByteFunc  := GreenBeretInByte;
      aProcs[1].oInterruptFunc := GreenBeretInterrupt;
      aProcs[1].oMemory := aZ80Mem;
      aProcs[1].nNMIInt := $66;
      GreenBeretInitDriver(aGraph);
      oCreateScreen := GreenBeretCreateScreen;
      oDestroyDriver := GreenBeretDestroyDriver;
      nScrW := 256;
      nScrH := 256;
      nScrDX := 0;
    end
    else begin
      ShowMessage('Invalid Driver:'#13+oRomsInfo.cDriver);
      lStopEmulation := true;
      oROMSInfo.Free;
      cbDrivers.Enabled := true;
      lbGames.Enabled := true;
      Dispose(aGraph);
      Exit
    end;
    GetMem(aGraph, $20000);

    if lDoubleScreen then begin
      frmGameScreen.ClientWidth := 2*nScrW;
      frmGameScreen.ClientHeight := 2*nScrH;
    end
    else begin
      frmGameScreen.ClientWidth := nScrW;
      frmGameScreen.ClientHeight := nScrH;
    end;

    frmGameScreen.lCanClose := false;
    frmGameScreen.Show;
    frmGameScreen.CreateDIB;
    lStopEmulation := false;
    sbStart.Caption := 'Stop';
    sbReset.Enabled := true;
    sbSprites.Enabled := oROMSInfo.nSprites>0;
    sbCart.Enabled := oROMSInfo.lCart;
    sbDisasm.Enabled := true;

    while not lStopEmulation do begin

      if frmDebug.GetDebugState<>STATE_PAUSED then begin
        if lDebug then begin
          if lBreakPoint then EvalBreakPoints;
          EvalDebug;
          EvalOneInstr(1);

          if frmDebug.GetDebugState=STATE_STEP then
            frmDebug.SetDebugState(STATE_PAUSED);

          if @oCreateScreen<>nil then oCreateScreen;

          if lDoubleScreen then
            CopySurfaceToScreen2x(frmGameScreen.Canvas.Handle)
          else
            CopySurfaceToScreen(frmGameScreen.Canvas.Handle);
          Application.ProcessMessages;
        end
        else begin
          if lBreakPoint then begin
            EvalBreakPoints;
            EvalOneInstr(1);
            if aZ80Regs^.nTicks=0 then Application.ProcessMessages;
          end
          else begin
            {
            Writeln(oDebug, 'AF:'+IntToHex(aZ80Regs.AF.W , 4)+
                           ' HL:'+IntToHex(aZ80Regs.HL.W , 4)+
                           ' DE:'+IntToHex(aZ80Regs.DE.W , 4)+
                           ' BC:'+IntToHex(aZ80Regs.BC.W , 4)+
                           ' PC:'+IntToHex(aZ80Regs.PC.W , 4)+
                           ' SP:'+IntToHex(aZ80Regs.SP.W , 4)+
                           ' IX:'+IntToHex(aZ80Regs.IX.W , 4)+
                           ' IY:'+IntToHex(aZ80Regs.IY.W , 4));

            EvalOneInstr(1);
            }
            EvalInstr(1);
            Application.ProcessMessages;
          end;
        end;
      end
      else begin
        if lDoubleScreen then begin
          CopySurfaceToScreen2x(frmGameScreen.Canvas.Handle)
        end
        else begin
          CopySurfaceToScreen(frmGameScreen.Canvas.Handle);
        end;
        Application.ProcessMessages;
      end;
    end;

    if @oDestroyDriver<>nil then oDestroyDriver;
    oDestroyDriver := nil;
    oCreateScreen := nil;
    oLoadCart := nil;
    oShowCharSet := nil;
  end;
end;

procedure TfrmEmulator.FillGameList;
var
  nPos, I: Integer;
  cAux, cDriver: String;
begin
  cDriver := cbDrivers.Items[cbDrivers.ItemIndex];
  lbGames.Items.Clear;
  for i := 1 to aString.Count do begin
    cAux := aString[i-1];
    nPos := Pos(#1, cAux);
    if nPos<>0 then begin
      if Copy(cAux, 1, nPos-1)=cDriver then begin
        Delete(cAux, 1, nPos);
        lbGames.Items.Add(cAux);
      end;
    end;
  end;
  lbGames.ItemIndex := 0;
end;

procedure TfrmEmulator.FormCreate(Sender: TObject);
var
  nGalIndex, I, nPos, nResult: Integer;
  aSearchRec: TSearchRec;
  cFileName, cTitle, cDriver: String;
begin
  Caption := Application.Title;
  {AssignFile(oDebug, 'DEBUG.LOG');
  Rewrite(oDebug);}

  New(aZ80Mem);
  sbReset.Enabled := false;
  sbSprites.Enabled := false;
  sbCart.Enabled := false;
  sbDSW.Enabled := false;
  sbDisasm.Enabled := false;

  Left := 0;
  Top := 0;

  aString := TStringList.Create;
  aString.Clear;
  aString.Sorted := true;

  nResult := FindFirst(ExtractFilePath(Application.ExeName)+'*.ini', $FF, aSearchRec);
  while nResult = 0 do begin
    cFileName := ExtractFilePath(Application.ExeName)+aSearchRec.Name;
    ExtractTitle(cFileName, cTitle, cDriver);
    aString.Add(cDriver+#1+cTitle+#2+cFileName);
    nResult := FindNext(aSearchRec);
  end;
  FindClose(aSearchRec);

  cbDrivers.Items.Clear;
  cDriver := '';
  nGalIndex := 0;
  for i := 1 to aString.Count do begin
    nPos := Pos(#1, aString[i-1]);
    if nPos<>0 then begin
      if cDriver<>Copy(aString[i-1], 1, nPos-1) then begin
        cDriver := Copy(aString[i-1], 1, nPos-1);
        if cDriver='GALAXIAN' then
          nGalIndex := cbDrivers.Items.Add(cDriver)
        else
          cbDrivers.Items.Add(cDriver);
      end;
    end;
  end;
  cbDrivers.ItemIndex := nGalIndex;
  FillGameList;

  lDoubleScreen := cbDoubleScr.Checked;
  cbBreakPoint.Checked := false;
  lStopEmulation := true;
end;

procedure TfrmEmulator.cbDebugClick(Sender: TObject);
begin
  lDebug := cbDebug.Checked;
  if lDebug then begin
    if not frmDebug.Visible then frmDebug.Show;
    frmDebug.Top := Top+Height+2;
    frmDebug.Width := Width;
    frmDebug.Left := Left;
    frmDebug.SetDebugState(STATE_RUNNING);
  end
  else begin
    if frmDebug.Visible then frmDebug.Hide;
  end;
end;

procedure TfrmEmulator.cbDoubleScrClick(Sender: TObject);
begin
  lDoubleScreen := cbDoubleScr.Checked;
  if lDoubleScreen then begin
    frmGameScreen.ClientWidth := 2*nScrW;
    frmGameScreen.ClientHeight := 2*nScrH;
  end
  else begin
    frmGameScreen.ClientWidth := nScrW;
    frmGameScreen.ClientHeight := nScrH;
  end;
end;

procedure TfrmEmulator.FormDestroy(Sender: TObject);
begin
  {CloseFile(oDebug);}
  Dispose(aZ80Mem);
  aString.Free;
end;

procedure TfrmEmulator.cbDriversChange(Sender: TObject);
begin
  FillGameList;
end;

procedure TfrmEmulator.lbGamesDrawItem(Control: TWinControl; Index: Integer;
  oRect: TRect; State: TOwnerDrawState);
var
  nPos: Integer;
  cAux: String;
begin
  with lbGames.Canvas, oRect do begin
    if ODSELECTED in State then begin
      Brush.Color := CLGRAY;
      Font.Color := CLWHITE;
      Font.Style := [FSBOLD];
    end
    else begin
      Brush.Color := lbGames.Color;
      Font.Color := CLBLACK;
      Font.Style := [];
    end;
    FillRect(oRect);
    cAux := lbGames.Items[Index];
    nPos := Pos(#2, cAux);
    if nPos<>0 then begin
      cAux := Copy(cAux, 1, nPos-1);
    end;
    TextOut(left, top, cAux);
  end;
end;

procedure TfrmEmulator.lbGamesDblClick(Sender: TObject);
begin
  sbStart.Click;
end;

procedure TfrmEmulator.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not lStopEmulation then begin
    sbStart.Click;
  end;
  Action := CAFREE;
end;

procedure TfrmEmulator.cbDriversDrawItem(Control: TWinControl; Index: Integer;
  oRect: TRect; State: TOwnerDrawState);
begin
  with cbDrivers.Canvas, oRect do begin
    if ODSELECTED in State then begin
      Brush.Color := CLWHITE;
      Font.Color := CLRED;
    end;
    FillRect(oRect);
    TextOut(Left+18, Top, cbDrivers.Items[Index]);
  end;
end;

procedure TfrmEmulator.sbResetClick(Sender: TObject);
begin
  aZ80Regs^.SP.W := $F000;
  aZ80Regs^.PC.W := $0000;
end;

procedure TfrmEmulator.sbCharSetsClick(Sender: TObject);
begin
  frmCharSet.Left := Left+64;
  frmCharSet.Top := Top+64;
  frmCharSet.SetType(aCharSet, 256, oRomsInfo.nCharSet, 'Char Sets');
  frmCharSet.ShowModal;
end;

procedure TfrmEmulator.sbSpritesClick(Sender: TObject);
begin
  if @oShowCharSet=nil then begin
    frmCharSet.SetType(aSprites, 64, oRomsInfo.nCharSet, 'Sprites');
    frmCharSet.ShowModal;
  end
  else begin
    frmSpriteSet.SetTypeX;
    frmSpriteSet.ShowModal;
  end;
end;

procedure TfrmEmulator.sbCartClick(Sender: TObject);
begin
  if @oLoadCart<>nil then oLoadCart;
end;

procedure TfrmEmulator.cbBreakPointClick(Sender: TObject);
begin
  lBreakPoint := cbBreakPoint.Checked;
  sbAddBreak.Enabled := lBreakPoint;
  sbDelBreak.Enabled := lBreakPoint;
  cbBreak.Enabled := lBreakPoint;
end;

procedure TfrmEmulator.sbAddBreakClick(Sender: TObject);
begin
  frmBreakPoint.SetPos(Left+sbAddBreak.Left+8, Top+sbAddBreak.Top+8);
  frmBreakPoint.ShowModal;
  if frmBreakPoint.ModalResult=MROK then begin
    cbBreak.ItemIndex := cbBreak.Items.Add(frmBreakPoint.edAddr.Text);
  end;
end;

procedure TfrmEmulator.sbDisasmClick(Sender: TObject);
begin
  if frmDisasm.Visible then begin
    frmDisasm.Hide;
  end
  else begin
    if frmDisasm.IsCleared then frmDisasm.Disasm(aZ80Mem, aZ80Regs^.nMaxROM);
    frmDisasm.SetPos(frmGameScreen.Left+frmGameScreen.Width+2, Top, -1, frmGameScreen.Height);
    frmDisasm.Show;
  end;
end;

procedure TfrmEmulator.cbBreakDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  with cbBreak.Canvas, Rect do begin
    if ODSELECTED in State then begin
      Brush.Color := CLWHITE;
      Font.Color := CLRED;
    end;
    FillRect(Rect);
    TextOut(Left+2, Top, cbBreak.Items[Index]);
  end;
end;

procedure TfrmEmulator.sbDelBreakClick(Sender: TObject);
begin
  if cbBreak.ItemIndex>=0 then begin
    cbBreak.Items.Delete(cbBreak.ItemIndex);
    if cbBreak.Items.Count>0 then
      cbBreak.ItemIndex := 0
    else
      cbBreak.ItemIndex := -1
  end;
end;

end.
