{$O+}
unit
  UScramb;

interface

uses
  Classes, Windows, Forms, UDIBSurf, UZ80Var, UZ80, UGameScr, USprite, SysUtils, UGalax;



  function ScrambleGetByte(nEnder: Word): Byte; pascal;
  procedure ScramblePutByte(nEnder, nValue: Word); pascal;
  procedure ScrambleInitDriver;

implementation

const
  aScramblePalette: array[0..31+4] of byte =
    ($00,$17,$C7,$F6,$00,$17,$C0,$3F,
     $00,$07,$C0,$3F,$00,$C0,$C4,$07,
     $00,$C7,$31,$17,$00,$31,$C7,$3F,
     $00,$F6,$07,$F0,$00,$3F,$07,$C4,
     $00,$88,$cc,$ff);



function ScrambleGetByte(nEnder: Word): Byte;
var
  RV: Byte;
begin
  if nEnder=$8202 then begin
    ScrambleGetByte := $6F;
    exit
  end;


  if (nEnder=$7000) or (nEnder=$7008) then begin
    Inc(nWatchDog);
    ScrambleGetByte := nWatchDog;
    exit
  end;

  if nEnder=$8100 then begin
    rv := $FF;
    if (GetAsyncKeyState(VK_3) and $8000)<>0       then rv  := rv and $7F;
    if (GetAsyncKeyState(VK_4) and $8000)<>0       then rv  := rv and $BF;
    if (GetAsyncKeyState(VK_LEFT) and $8000)<>0    then rv  := rv and $DF;
    if (GetAsyncKeyState(VK_RIGHT) and $8000)<>0   then rv  := rv and $EF;
    if (GetAsyncKeyState(VK_CONTROL) and $8000)<>0 then rv  := rv and $F7;
    if (GetAsyncKeyState(VK_C) and $8000)<>0       then rv  := rv and $FB;
    if (GetAsyncKeyState(VK_Z) and $8000)<>0       then rv  := rv and $FD;
    if (GetAsyncKeyState(VK_W) and $8000)<>0       then rv  := rv and $FE;
    ScrambleGetByte := rv;
    exit
  end;

  if nEnder=$8101 then begin
    rv := $FF;
    rv := rv and not $03;
    if (GetAsyncKeyState(VK_1) and $8000)<>0  then rv  := rv and $7F;
    if (GetAsyncKeyState(VK_2) and $8000)<>0  then rv  := rv and $BF;
    {
    if (GetAsyncKeyState(VK_A) and $8000)<>0  then rv  := rv and $CF;
    if (GetAsyncKeyState(VK_D) and $8000)<>0  then rv  := rv and $EF;
    if (GetAsyncKeyState(VK_TAB) and $8000)<>0  then rv  := rv and $F7;
    if (GetAsyncKeyState(VK_MENU) and $8000)<>0  then rv  := rv and $FB;
    }
    ScrambleGetByte := rv;
    exit
  end;

  if nEnder=$8102 then begin
    rv := $FF;
    if (aZ80Regs^.PC.W=$00e4) then RV := RV and $7f;
    rv := rv and not ($06);
    if (GetAsyncKeyState(VK_DOWN) and $8000)<>0  then rv  := rv and $BF;
    if (GetAsyncKeyState(VK_UP) and $8000)<>0  then rv  := rv and $EF;
    if (GetAsyncKeyState(VK_S) and $8000)<>0  then rv  := rv and $FE;

    ScrambleGetByte := rv;
    exit
  end;

  ScrambleGetByte := aZ80Mem^[nEnder];
end;


procedure ScramblePutByte(nEnder, nValue: Word);
begin
  if (nEnder<=oRomsInfo.nMaxRom) then exit;
  aZ80Mem^[nEnder] := nValue
end;

procedure ScrambleInitDriver;
begin
  GalaxianConvertColor(@aScramblePalette);
end;


end.