unit usprset;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, UDIBSurf, Spin, USprite, UMameChr, Tabs;

type
  TfrmSpriteSet = class(TForm)
    Panel1: TPanel;
    pnlScreen: TPanel;
    bbOk: TBitBtn;
    pbScreen: TPaintBox;
    Panel3: TPanel;
    cbSets: TComboBox;
    Label1: TLabel;
    sePalette: TSpinEdit;
    cbFlipX: TCheckBox;
    cbFlipY: TCheckBox;
    procedure pbScreenPaint(Sender: TObject);
    procedure sePaletteChange(Sender: TObject);
    procedure cbSetsChange(Sender: TObject);
    procedure cbFlipClick(Sender: TObject);
  private
    { Private declarations }
    nFlip,
    nSet,
    nSets,
    nPalette,
    nZoom: Integer;
    aSprite: PSpriteSet;
    nMaxSprite: Integer;
    cCaption: String;
    nSetCount: Integer;
    aXSprite: PArrayGFXElement;
    procedure ShowSpriteSet(nIndex: Integer);
  public
    { Public declarations }
    procedure SetType(xSprite: PSpriteSet; nMax, aSets: Integer; cStr: String);
    procedure SetTypeX;
  end;

var
  frmSpriteSet: TfrmSpriteSet;

implementation

uses UZ80Var;

{$R *.DFM}

procedure TfrmSpriteSet.SetType(xSprite: PSpriteSet; nMax, aSets: Integer; cStr: String);
begin
  aSprite := xSprite;
  nMaxSprite := nMax;
  cCaption := cStr;
  Caption := cCaption;
  nSets := aSets;
  nSet := 0;
  nSet := 0;
  nZoom := 3;

  nPalette := 0;
end;

procedure TfrmSpriteSet.SetTypeX;
var
  I: Integer;
begin
  nFlip := 0;
  oShowCharSet(nSetCount, aXSprite);
  cbSets.Clear;
  for i := 0 to nSetCount-1 do begin
    cbSets.Items.Add(aXSprite^[i].cName);
  end;
  cbSets.ItemIndex := 0;
  ShowSpriteSet(0);
  pbScreen.Refresh;
end;

procedure TfrmSpriteSet.ShowSpriteSet(nIndex: Integer);
var
  nColor, nW, nH, nLin, nCol, I, J: Integer;
begin
  FillSurface(0);
  with aXSprite^[nIndex]^ do begin
    nW := aXSprite^[nIndex]^.Width+2;
    nH := aXSprite^[nIndex]^.Height+2;
    nLin := 2;
    nCol := 2;
    nColor := nStartPalette+color_granularity*sePalette.Value;
    for i := 0 to total_elements-1 do begin
      xPutColorSprite(nCol, nLin, nColor, nFlip, gfxdata^[i]);
      Inc(nCol, nW);
      if (nCol>(pbScreen.Width div 2)) or (nCol>(255-width)) then begin
        nCol := 2;
        Inc(nLin, nH);
        if (nLin>(pbScreen.Height div 2)) or (nLin>(255-height)) then break;
      end;
    end;
  end;
end;


procedure TfrmSpriteSet.pbScreenPaint(Sender: TObject);
var
  nZX, nZY, nColor, I, J, nX, nY, nSprite: Integer;
begin
  with pbScreen.Canvas do begin
    gdiSelectPalette(Handle, DIBhpalette, 0);
    RealizePalette(Handle);
    StretchBlt(Handle, 0, 0, 2*DIBWidth, 2*DIBHeight,
               DIBDC, 0, 0, DIBWidth, DIBHeight, SRCCOPY);
  end;
end;

procedure TfrmSpriteSet.sePaletteChange(Sender: TObject);
begin
  ShowSpriteSet(cbSets.ItemIndex);
  pbScreen.Refresh;
end;

procedure TfrmSpriteSet.cbSetsChange(Sender: TObject);
begin
  sePalette.Value := 0;
  if cbSets.ItemIndex>=0 then begin
    ShowSpriteSet(cbSets.ItemIndex);
    pbScreen.Refresh;
  end;
end;

procedure TfrmSpriteSet.cbFlipClick(Sender: TObject);
begin
  nFlip := 0;
  if cbFlipX.Checked then nFlip := nFlip or $80;
  if cbFlipY.Checked then nFlip := nFlip or $40;
  ShowSpriteSet(cbSets.ItemIndex);
  pbScreen.Refresh;
end;

end.
