{$ALIGN OFF}
{ UZ80 - Z80 emulator                                            }
{ =-=-=-=-=-=-=-=-=-=-                                           }
{ by pscardoso@lme.usp.br                                        }
{ do not change the source, this file is automatically generated }
{ if you find a bug, send information to the author.             }

{ Last changes }
{ 21/MAY/1998 - Fixed R register incremention. Now ladybug works. }
{ 14/MAY/1998 - Fixed IN R,(X) (this instruction affect flags!    }
{ 07/MAY/1998 - Fixed LDIR, CPIR, OTIR, INIR, etc (now Galaxians  
                bee attack us again.                              }

{ 06/MAY/1998 - Public release (version 0.2)                      }
{ 04/MAY/1998 - implementation of INI, IND, INIR, INDR            }
{ 03/MAY/1998 - implementation of CPI, CPD, CPIR, CPDR            }
{ 02/MAY/1998 - implementation of OUTI, OTIR, OUTD, OTDR          }
{ 30/APR/1998 - fixed bugs in CCF                                 }
{ 28/APR/1998 - fixed LDIR, LDDR functions (problems with delphi) }
{ 27/APR/1998 - now EvalXXXInstr preservs (e)si, (e)di, (e)bx.    }
{ 16/APR/1998 - First public release (version 0.1)                }

unit UZ80;

interface

const
  IGNORE_INT = $FF;
  IPERIOD    = $50000;
  S_FLAG = $80;
  Z_FLAG = $40;
  U2FLAG = $20;
  H_FLAG = $10;
  U1FLAG = $08;
  P_FLAG = $04;
  V_FLAG = $04;
  N_FLAG = $02;
  C_FLAG = $01;
  MAX_PROCS     = 10;
  FREG          = 00;
  AREG          = 01;
  CREG          = 02;
  BREG          = 03;
  EREG          = 04;
  DREG          = 05;
  LREG          = 06;
  HREG          = 07;
  IXLREG        = 08;
  IXHREG        = 09;
  IYLREG        = 10;
  IYHREG        = 11;
  PCLREG        = 12;
  PCHREG        = 13;
  SPLREG        = 14;
  SPHREG        = 15;
  F1LREG        = 16;
  A1HREG        = 17;
  C1LREG        = 18;
  B1HREG        = 19;
  E1LREG        = 20;
  D1HREG        = 21;
  L1LREG        = 22;
  H1HREG        = 23;
  IFF1          = 24;
  IFF2          = 25;
  IREG          = 26;
  RREG          = 27;
  INTZL         = 28;
  INTZH         = 29;
  MODEL         = 30;
  MODEH         = 31;
  TICKL         = 32;
  TICKH         = 33;
  MAXROML       = 34;
  MAXROMH       = 35;
  MAXRAML       = 36;
  MAXRAMH       = 37;
  PREVPC        = 38;
  COUNTTICKSL   = 40;
  COUNTTICKSH   = 41;
  MEMORY        = 42;
  GETBYTEFUNC   = 46;
  PUTBYTEFUNC   = 50;
  OUTBYTEFUNC   = 54;
  INBYTEFUNC    = 58;
  INTERRUPTFUNC = 62;
  MAXRAMXXX     = 66;
  NMIINT        = 68;
  HALTED        = 70;
  IM            = 72;
  PENDINGNMI    = 74;
  PENDINGIRQ    = 78;
  AFREG         = 00;
  BCREG         = 02;
  DEREG         = 04;
  HLREG         = 06;
  IXREG         = 08;
  IYREG         = 10;
  PCREG         = 12;
  SPREG         = 14;
  AF1REG        = 16;
  BC1REG        = 18;
  DE1REG        = 20;
  HL1REG        = 22;
  IFFREG        = 24;
  IRREG         = 26;
  INTZ          = 28;
  MODE          = 30;
  TICKCOUNT     = 32;
  MAXROM        = 34;
  MAXRAM        = 36;
  COUNTTICKS    = 40;

type
  TPair = record
    case byte of
      0: (l, h: byte);
      1: (w: Word);
  end;
  TZ80ASMRegs = record
    AF,BC,DE,HL,IX,IY,PC,SP: TPair;
    AF1,BC1,DE1,HL1: TPair;
    IFF1, IFF2: Byte;
    I, R: Byte;
    nIntZFlag: Word;
    nMode: Word;
    nTicks: Word;
    nMaxRom, nMaxRam, nPrevPC: Word;
    nCountTicks: Word;
  end;
  TProcessor = record
    aRegs: array[0..MEMORY-1] Of Byte;
    oMemory: Pointer;
    oGetByteFunc: function (nEnder: Word): Byte; pascal;
    oPutByteFunc: procedure (nEnder, nValue: Word); pascal;
    oOutByteFunc: procedure (nEnder, nValue: Word); pascal;
    oInByteFunc: function (nEnder: Word): Byte; pascal;
    oInterruptFunc: procedure; pascal;
    nMaxRAM, nNMIInt, nHalted, nIM: Word;
    nPendingNMI, nPendingIRQ: LongInt;

  end;

var
  aProcs: array[1..MAX_PROCS] of TProcessor;

procedure EvalInstr(nProc: Word);
procedure EvalOneInstr(nProc: Word);

implementation

const
 nStructSize = SizeOf(TProcessor);
 {$I TABLES.INC}

procedure OpCode; forward;
procedure ExecOpCode; forward;
procedure OpCodeDDCB; forward;
procedure OpCodeFDCB; forward;
procedure OpCodeCB; forward;
procedure OpCodeDD; forward;
procedure OpCodeED; forward;
procedure OpCodeDDED; forward;
procedure OpCodeFDED; forward;
procedure OpCodeFD; forward;

procedure PutByte; assembler;
asm
  cmp   bx, word ptr esi[MAXROM]
  jb    @Exit
  pusha
  xor   ah, ah
  push  ebx
  push  eax
  call  dword ptr esi[PUTBYTEFUNC]
  popa
@Exit:
end;

procedure OutByte; assembler;
asm
  pusha
  xor   ah, ah
  xor   bh, bh
  push  ebx
  push  eax
  call  dword ptr esi[OUTBYTEFUNC]
  popa
end;

procedure GetByte; assembler;
asm
  cmp   word ptr esi[MAXRAM], $FFFF
  je    @UseFunc
  cmp   bx, word ptr esi[MAXRAM]
  ja    @UseFunc
  push  ebx
  push  edi
  and   ebx, $FFFF
  mov   edi, dword ptr esi[MEMORY]
  mov   al, byte ptr edi[ebx]
  pop   edi
  pop   ebx
  jmp   @Exit
@UseFunc:
  push  ebx
  push  ecx
  push  edx
  push  esi
  push  edi
  push  es
  push  ds

  mov   edx, eax
  push  edx
  push  ebx
  call  dword ptr esi[GETBYTEFUNC]
  pop   edx
  mov   dl, al
  mov   eax, edx

  pop   ds
  pop   es
  pop   edi
  pop   esi
  pop   edx
  pop   ecx
  pop   ebx
@Exit:
end;

procedure InByte; assembler;
asm
  push  ebx
  push  ecx
  push  edx
  push  esi
  push  edi
  push  es
  push  ds

  mov   edx, eax
  push  edx
  and   eax, $FF
  mov   ah, byte ptr esi[AREG]
  push  eax
  call  dword ptr esi[INBYTEFUNC]
  pop   edx
  mov   dl, al
  mov   eax, edx

  pop   ds
  pop   es
  pop   edi
  pop   esi
  pop   edx
  pop   ecx
  pop   ebx
end;

procedure EIInterrupt; assembler;
asm
  pusha
  cmp  byte ptr esi[PENDINGIRQ+3], $01
  jne  @DoInterrupt

  cmp  word ptr esi[PENDINGNMI], 0
  je   @Exit

@DoInterrupt:

  cmp  word ptr esi[PENDINGNMI], 0
  jne  @StartInt

  cmp  word ptr esi[IFF1], 0
  je   @Exit

@StartInt:
  mov  word ptr esi[PREVPC], $FFFF
  mov  word ptr esi[IFF1], 0

  cmp  word ptr esi[HALTED], 1  
  jne  @IsNotHalted

  inc  word ptr esi[PCREG]
  mov  word ptr esi[HALTED], 0

@IsNotHalted:

  cmp  word ptr esi[PENDINGNMI], 0
  je   @NoPendingNMI
  { PUSH PC }
  mov  word ptr esi[PENDINGNMI], 0
  dec  word ptr esi[SPREG]
  mov  bx, word ptr esi[SPREG]
  mov  al, byte ptr esi[PCHREG]
  call PutByte
  dec  word ptr esi[SPREG]
  mov  bx, word ptr esi[SPREG]
  mov  al, byte ptr esi[PCLREG]
  call PutByte
  mov  ax, word ptr esi[NMIINT]
  mov  word ptr esi[PCREG], ax
  jmp  @Exit

@NoPendingNMI:
  mov  byte ptr esi[PENDINGIRQ+3], $01

  cmp  byte ptr esi[IM], 0
  je   @IsIM0                   { Interruption mode is 0 }

  cmp  byte ptr esi[IM], 3
  je   @IsIM2                   { Interruption mode is 2 }

  { IM-undoc, IM1 }
  { push PC }
  { PC <- 38h }
  dec  word ptr esi[SPREG]
  mov  bx, word ptr esi[SPREG]
  mov  al, byte ptr esi[PCHREG]
  call PutByte
  dec  word ptr esi[SPREG]
  mov  bx, word ptr esi[SPREG]
  mov  al, byte ptr esi[PCLREG]
  call PutByte
  mov  word ptr esi[PCREG], $0038
  je   @Exit

@IsIM0:
  cmp  byte ptr esi[PENDINGIRQ+2], $CD
  jne  @IsNotCall
  { push PC }
  { PC <- 38h }
  dec  word ptr esi[SPREG]
  mov  bx, word ptr esi[SPREG]
  mov  al, byte ptr esi[PCHREG]
  call PutByte
  dec  word ptr esi[SPREG]
  mov  bx, word ptr esi[SPREG]
  mov  al, byte ptr esi[PCLREG]
  call PutByte
  mov  word ptr esi[PCREG], $FFFF
  je   @Exit

@IsNotCall:
  cmp  byte ptr esi[PENDINGIRQ+2], $C3
  jne  @IsNotJump
  mov  word ptr esi[PCREG], $FFFF
  je   @Exit

@IsNotJump:
  xor  ax, ax
  mov  al, byte ptr esi[PENDINGIRQ+0]
  call ExecOpCode

  jmp  @Exit

@IsIM2:
  { IM2 }
  { push PC }
  { PC <- Mem[I shl 8 + FF] }
  dec  word ptr esi[SPREG]
  mov  bx, word ptr esi[SPREG]
  mov  al, byte ptr esi[PCHREG]
  call PutByte
  dec  word ptr esi[SPREG]
  mov  bx, word ptr esi[SPREG]
  mov  al, byte ptr esi[PCLREG]
  call PutByte
  mov  bh, byte ptr esi[IREG]
  mov  bl, byte ptr esi[PENDINGIRQ]
  call GetByte
  xchg ah, al
  inc  bx
  call GetByte
  xchg ah, al
  mov  word ptr esi[PCREG], ax

@Exit:

  popa
end;

procedure Interrupt; assembler;
asm
  pusha
  call dword ptr esi[INTERRUPTFUNC]
  call EIInterrupt
  popa
end;


{$I OPCODE.INC}
{$I OPCDDDCB.INC}
{$I OPCDFDCB.INC}
{$I OPCODECB.INC}
{$I OPCODEDD.INC}
{$I OPCODEED.INC}
{$I OPCDDDED.INC}
{$I OPCDFDED.INC}
{$I OPCODEFD.INC}

procedure EvalInstr(nProc: Word);
var
  nStrOffs: LongInt;
begin
  nStrOffs := nStructSize*(nProc-1);
  asm
    push esi
    push edi
    push ebx
    mov  esi, offset aProcs
    add  esi, nStrOffs
    mov  word ptr esi[TICKCOUNT], 0    { initialize cycles counter }
@LoopGame:
    inc  byte ptr esi[RREG]
    call OpCode
    mov  ax, word ptr esi[TICKCOUNT]
    cmp  ax, 50000
    jb   @LoopGame
    call Interrupt
    pop  ebx
    pop  edi
    pop  esi
  end;
end;

procedure EvalOneInstr(nProc: Word);
var
  nStrOffs: LongInt;
begin
  nStrOffs := nStructSize*(nProc-1);
  asm
    push esi
    push edi
    push ebx
    mov  esi, offset aProcs
    add  esi, nStrOffs
    inc  byte ptr esi[RREG]
    call OpCode
    mov  ax, word ptr esi[TICKCOUNT]
    cmp  ax, 50000
    jb   @NoInt
    call Interrupt
    mov  word ptr esi[TICKCOUNT], 0    { initialize cycles counter }
@NoInt:
    pop  ebx
    pop  edi
    pop  esi
  end;
end;

end.
