unit UZ80Var;

interface
uses
  ULoadROM, UZ80, USprite, UMAMEChr;

type
  TMemory = array[0..65535] of Byte;
  PMemory = ^TMemory;
  TCreateScreen = procedure;
  TLoadCart = procedure;
  TShowCharSet = procedure(var nQtd: Integer; var aGFX: PArrayGFXElement);
  TPalStr = record
    R, G, B: Byte
  end;

const
  oCreateScreen: procedure = nil;
  VK_1 = Byte('1');
  VK_2 = Byte('2');
  VK_3 = Byte('3');
  VK_4 = Byte('4');
  VK_5 = Byte('5');
  VK_6 = Byte('6');
  VK_7 = Byte('7');
  VK_8 = Byte('8');
  VK_9 = Byte('9');
  VK_0 = Byte('0');
  VK_A = Byte('A');
  VK_B = Byte('B');
  VK_C = Byte('C');
  VK_D = Byte('D');
  VK_E = Byte('E');
  VK_F = Byte('F');
  VK_G = Byte('G');
  VK_H = Byte('H');
  VK_I = Byte('I');
  VK_J = Byte('J');
  VK_K = Byte('K');
  VK_L = Byte('L');
  VK_M = Byte('M');
  VK_N = Byte('N');
  VK_O = Byte('O');
  VK_P = Byte('P');
  VK_Q = Byte('Q');
  VK_R = Byte('R');
  VK_S = Byte('S');
  VK_T = Byte('T');
  VK_U = Byte('U');
  VK_V = Byte('V');
  VK_W = Byte('W');
  VK_X = Byte('X');
  VK_Y = Byte('Y');
  VK_Z = Byte('Z');


var
  nScrW, nScrH, nScrDX, nScrDY: Integer;
  oLoadCart: TLoadCart;
  oShowCharSet: TShowCharSet;
  lDoubleScreen: Boolean;
  aZ80Mem: PMemory;
  lDraw: Boolean;
  oROMSInfo: TROMSInfo;
  aZ80Regs: ^TZ80ASMRegs;
  lBreakPoint: Boolean = false;
  lStopEmulation: Boolean;
  aSprites: PSpriteSet;
  aCharSet: PSpriteSet;
  aPalette: array[0..255] of TPalStr;

const
  nWatchDog: Integer = 0;

procedure CopySurfaceToScreen2X(destDC: Integer);
procedure CopySurfaceToScreen(destDC: Integer);
function Bit(nByte1, nByte2: Byte): Byte;

implementation

uses
  UDIBSurf, UGameScr, Windows;

procedure CopySurfaceToScreen2X(destDC: Integer);
begin
  gdiSelectPalette(destDC, DIBhpalette, 0);
  RealizePalette(destDC);

  {
  StretchBlt(destDC, 0, 0, 2*DIBWidth, 2*DIBHeight,
             DIBDC, 0, 0, DIBWidth, DIBHeight, SRCCOPY);
  }

  StretchBlt(destDC, 0, 0, 2*DIBWidth, 2*DIBHeight,
             DIBDC, nScrDX, nScrDY, DIBWidth, DIBHeight, SRCCOPY);
end;

procedure CopySurfaceToScreen(destDC: Integer);
begin
  gdiSelectPalette(destDC, DIBhpalette, 0);


  BitBlt(destDC,0,0,DIBWidth,DIBHeight,DIBDC,nScrDX,nScrDY,SRCCOPY);


end;

function Bit(nByte1, nByte2: Byte): Byte;
const
  aBytes: array[0..7] of Byte = (1,2,4,8,16,32,64,128);
begin
  if (nByte1 and aBytes[nByte2])=0 then
    Bit := 0
  else
    Bit := 1
end;


end.
